// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('winchit', ['ionic', 'winchit.controllers', 'winchit.services', 'ngCordova', 'credit-cards', 'creditCardInput', 'ion-floating-menu', 'ionic.ion.imageCacheFactory'])

	.run(function ($ionicPlatform, $rootScope, $timeout, $ionicPopup, $state, generalService, $cordovaDevice, $cordovaToast, $ionicHistory, $ionicLoading, $cordovaSplashscreen) {
		$ionicPlatform.ready(function () {
			// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
			// for form inputs)
			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(false);

			}
			if (window.StatusBar) {
				// org.apache.cordova.statusbar required
				StatusBar.styleDefault();
			}


			// Check for network connection
			if (window.Connection) {
				if (navigator.connection.type == Connection.NONE) {
					$ionicLoading.hide();
					$cordovaToast
						.show('No Internet connection..', 'long', 'center')
						.then(function (success) {
							// success
						}, function (error) {
							// error
						});
				}
			}

			$ionicPlatform.registerBackButtonAction(function (e) {

				if ($rootScope.backButtonPressedOnceToExit) {
					ionic.Platform.exitApp();
				}

				else if ($ionicHistory.backView() && $state.current.name != 'app.login' && $state.current.name != 'app.home' && $state.current.name != 'maintenance') {
					$ionicHistory.goBack();
				}
				else {
					if ($state.current.name == 'app.home' || $state.current.name == 'app.login' || $state.current.name == 'maintenance') {
						$rootScope.backButtonPressedOnceToExit = true;
						window.plugins.toast.showShortCenter(
							"Press back button again to exit", function (a) { }, function (b) { }
						);
					} else {
						$rootScope.backButtonPressedOnceToExit = false;
					}
					setTimeout(function () {
						$rootScope.backButtonPressedOnceToExit = false;
					}, 2000);
					e.preventDefault();
					return false;
				}
			}, 101);

			//	One signal push notification

			document.addEventListener("deviceready", function () {
				// window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 4});
				var notificationOpenedCallback = function (result) {
					var data = result.notification.payload;
					if (data.additionalData && data.additionalData.targetUrl) {
						if (generalService.userlogged == 0) {
							$window.location.href = "#/app/login";
						}
						else {
							$window.location.href = data.additionalData.targetUrl;
						}
					}
				};
				window.plugins.OneSignal
					.startInit("417f05a2-9519-4390-975a-297f6cddfdfb", "1015363022088")
					.inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
					.handleNotificationOpened(notificationOpenedCallback)
					.handleNotificationReceived(function (data) {
						var data = data.payload;
						/*	alert( JSON.stringify(data));*/

						/*if(data){*/

						var dt = {
							"headings": data.title,
							"contents": data.body,
							"targetUrl": data.additionalData.targetUrl,
							"noti_service": data.additionalData.noti_service,
							"mobile": data.additionalData.mobile,
							"img": data.bigPicture
						};

						var notiData = (localStorage.getItem('notificationData') !== null) ? JSON.parse(localStorage.getItem('notificationData')) : [];
						notiData.push(dt);
						localStorage.setItem('notificationData', JSON.stringify(notiData));
					})
					.endInit();

				window.plugins.OneSignal.getIds(function (ids) {
					var token = ids.userId;
					var device_type = 0;
					if (device.platform == "Android") {
						var device_type = 1;
					} else {
						var device_type = 2;
					}
					var uuid = $cordovaDevice.getUUID();
					generalService.deviceRegData = {
						'token': token,
						'uuid': uuid,
						'device_type': device_type
					}
					console.log(generalService.deviceRegData);
					/*	alert(token);
						alert(uuid);
						alert(device_type);
*/
				});


				//automatic sms reader
				/* 	var permissions = cordova.plugins.permissions;
					permissions.hasPermission(permissions.READ_SMS, function (status) {
						if (status.hasPermission) {
	
						} else {
							permissions.requestPermission(permissions.READ_SMS, success, error);
							function error() {
								//alert("READ_SMS permission is not turned on");
							}
							function success(status) {
								if (!status.hasPermission)
									error();
							}
						}
					}); */


			}, false);
		});

		/* 		 var dt =  {
										 "headings":'New ',
										 "contents": "New Arrivals at ssj.Take a look.Don't miss it!!New Arrivals at ssj.Take a look.Don't miss it!!",
										 "targetUrl": '#/app/newarrivals',
										 "mobile":'9965473800',
										 "noti_service":7,
										 "img":''
									 };
		 
		 
					var  notiData= (localStorage.getItem('notificationData')!==null) ? JSON.parse(localStorage.getItem('notificationData')) : [];
									 notiData.push(dt);
									 localStorage.setItem('notificationData', JSON.stringify(notiData));  */

		$rootScope.authStatus = false;
		//stateChange event
		$rootScope.$on("$stateChangeStart", function (event, toState, toParams, fromState, fromParams) {
			$rootScope.authStatus = toState.authStatus;
			if ($rootScope.authStatus) {
			}
		});

		$rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
			console.log("URL : " + toState.url);
			if (toState.url == '/home') {
				$timeout(function () {
					angular.element(document.querySelector('.img-logo')).addClass("hideBar");
				}, 10);
				$ionicHistory.nextViewOptions({
					disableBack: true
				});
			} else {
				$timeout(function () {
					angular.element(document.querySelector('.img-logo')).removeClass("hideBar");
				}, 10);
			}
			if (toState.url == '/paydues' || toState.url == '/debitcard' || toState.url == '/creditcard' || toState.url == '/netbanking' || toState.url == '/resetpasswd' || toState.url == '/changepasswd' || toState.url == '/faq' || toState.url == '/address' || toState.url == '/feedback' || toState.url == '/privacy'  || toState.url == '/offerdetail' || toState.url == '/editprofile' || toState.url == '/terms' || toState.url == '/generalterms' || toState.url == '/about' || toState.url == '/otp' || toState.url == '/regotp' || toState.url == '/newarrivaldetail' || toState.url == '/login' || toState.url == '/signup' || toState.url == '/notification' || toState.url == '/notidetail' || toState.url == '/payview' || toState.url == '/existingscheme/:type/:id_scheme/:code/:is_pan_required' || toState.url == '/joinscheme/:id_scheme' || toState.url == '/select_weight' || toState.url == '/savingscheme/:id_classification/:cls_name' || toState.url == '/viewscheme/:id_scheme' || toState.url == '/chitscheme/:id_report' || toState.url == '/myschemes/:id_scheme' || toState.url == '/savedCards' || toState.url == '/payments/:id_report' || toState.url == '/giftitems' || toState.url == '/giftitems_detail' || toState.url == '/share' || toState.url == '/choose'  || toState.url == '/wallets' || toState.url == '/resetpassword' || toState.url == '/colsedaccounts' || toState.url == '/scheme_reg_req' || toState.url == '/vendor_enquiry' || toState.url == '/carrier_enquiry' || toState.url == '/showroom_img' || toState.url == '/categoryList' || toState.url == '/collections/:id_category' || toState.url == '/productdetail' || toState.url == '/notification' || toState.url == '/notidetail' || toState.url == '/notidetail') {
				console.log("match : " + toState.url);

				$timeout(function () {
					angular.element(document.querySelector('.app-header')).addClass("hideBar");
				}, 10);

				if (toState.url == '/debitcard' || toState.url == '/payview' || toState.url == '/creditcard' || toState.url == '/netbanking' || toState.url == '/paydues') {
					$timeout(function () {
						angular.element(document.querySelector('.app-footer')).addClass("hideBar");
					}, 10);
				}
				else {
					$timeout(function () {
						angular.element(document.querySelector('.app-footer')).removeClass("hideBar");
					}, 10);
				}
			}
			else if (toState.url == '/maintenance' || toState.url == '/intro_slide') {
				console.log("match : " + toState.url);
				$timeout(function () {
					angular.element(document.querySelector('.app-header')).addClass("hideBar");
					angular.element(document.querySelector('.app-footer')).addClass("hideBar");
				}, 10);
			}
			else {
				$timeout(function () {
					angular.element(document.querySelector('.app-header')).removeClass("hideBar");
					angular.element(document.querySelector('.app-footer')).removeClass("hideBar");
				}, 10);
			}
		});

	})

	.config(function ($stateProvider, $urlRouterProvider) {


		$stateProvider

			.state('app', {
				url: '/app',
				abstract: true,
				templateUrl: 'templates/menu.html',
				controller: 'AppCtrl'
			})

			//--------------------------------------



			.state('app.home', {
				url: '/home',
				views: {
					'menuContent': {
						templateUrl: 'templates/home.html',
						controller: 'HomeCtrl'
					}
				},
				authStatus: false
			})

			.state('app.login', {
				url: '/login',
				views: {
					'menuContent': {
						templateUrl: 'templates/tab-signin.html'
					}
				},
				authStatus: false
			})
			.state('app.signup', {
				url: '/signup',
				views: {
					'menuContent': {
						templateUrl: 'templates/tab-signup.html',
						controller: 'RegCtrl'
					}
				},
				authStatus: false
			})

			//settings menu
			.state('app.settings', {
				url: '/settings',
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/settings.html",
						controller: 'SettingsCtrl'
					}
				}
			})
			//share menu
			.state('app.share', {
				url: '/share',
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/share.html",
						controller: 'SharingCtrl'
					}
				}
			})

			//notification
			.state('app.notification', {
				url: '/notification',
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/notification.html",
						controller: 'NotificationCtrl'
					}
				}
			})
			//notif Detail
			.state('app.notidetail', {
				url: '/notidetail',
				params: { notiDetail: null },
				views: {
					'menuContent': {
						templateUrl: "templates/notifDetail.html",
						controller: 'NotificationCtrl'
					}
				}
			})

			//Customer support menu
			.state('app.customersupport', {
				url: '/customersupport',
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/customer_support.html",
						controller: 'CustomerSuppCtrl'
					}
				}
			})

			//--------------------------------------


			//otp
			.state('app.otp', {
				url: "/otp",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/otp.html",
						controller: "OtpCtrl"
					}
				}

			})

			//otp
			.state('app.regotp', {
				url: "/regotp",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/otp.html",
						controller: "ExistingRegOtpCtrl"
					}
				}

			})


			//dashboard
			.state('app.dashboard', {
				url: '/dashboard',
				views: {
					'menuContent': {
						templateUrl: 'templates/dashboard.html',
						controller: 'DashboardCtrl'
					}
				},
				authStatus: true
			})

			//myschemes
			.state('app.myschemes', {
				url: '/myschemes/:id_scheme',
				cache: false,
				resolve: {
					reportID: function ($http, $q, $stateParams) {
						return $stateParams.id_scheme;
					}
				},
				views: {
					'menuContent': {
						templateUrl: 'templates/myschemes.html',
						controller: 'ReportCtrl'

					}
				}
			})

			//individual scheme report
			.state('app.chitscheme', {
				url: '/chitscheme/:id_report',
				cache: false,
				resolve: {
					reportID: function ($http, $q, $stateParams) {
						return $stateParams.id_report;
					}
				},
				views: {
					'menuContent': {
						templateUrl: 'templates/chitscheme_report.html',
						controller: 'ReportCtrl'

					}
				}
			})

			//select payment
			.state('app.paynow', {
				url: "/paynow",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/proceed_payment.html",
						controller: "PaymentCtrl"
					}
				}

			})


			//paydues
			.state('app.paydues', {
				url: "/paydues",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/paydues.html",
						controller: "PaymentCtrl"
					}
				}

			})

			//payment views

			/*.state('app.payview', {
				url: "/payview",
				cache: false,
				views:{
						'menuContent': {
					templateUrl: "templates/payview.html",
					controller: "GatewayCtrl",
					 reload: true
					}
				}
			})*/


			.state('app.select_scheme', {
				url: "/select_scheme",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/select_scheme.html",
						controller: "SchemeCtrl"
					}
				}

			})

			.state('app.schemes', {
				url: '/schemes/:id_classification',
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/schemes.html",
						controller: "SavingSchemeCtrl"
					}
				}

			})

			.state('app.scheme', {
				url: '/joinscheme/:id_scheme',
				cache: false,
				resolve: {
					schemeID: function ($http, $q, $stateParams) {
						return $stateParams.id_scheme;
					}
				},
				views: {
					'menuContent': {
						templateUrl: 'templates/joinscheme.html',
						controller: 'JoinCtrl'

					}
				}
			})

			.state('app.existingscheme', {
				url: "/existingscheme/:type/:id_scheme/:code/:is_pan_required",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/existingscheme.html",
						controller: "SchemeCtrl"
					}
				}

			})

			//select weight
			.state('app.select_weight', {
				url: "/select_weight",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/select_weight.html",
						controller: "PaymentCtrl"
					}
				}

			})

			//wallet
			.state('app.wallet', {
				url: "/wallets",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/mywallets.html",
						controller: "WalletCtrl"
					}
				}

			})

			//edit profile
			.state('app.editprofile', {
				url: "/editprofile",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/edit_profile.html",
						controller: "ProfileCtrl"
					}
				}

			})

			//forget password
			.state('app.resetpasswd', {
				url: "/resetpasswd",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/changepasswd.html",
						controller: "changepwdCtrl"
					}
				}

			})

			//forget change password
			.state('app.resetpassword', {
				url: "/resetpassword",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/resetpassword.html",
						controller: "changepwdCtrl"
					}
				}

			})

			//change password after login
			.state('app.changepasswd', {
				url: "/changepasswd",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/changepwd.html",
						controller: "changepwdCtrl"
					}
				}

			})

			//payment history
			.state('app.payments', {
				url: '/payments/:id_report',
				cache: false,
				resolve: {
					reportID: function ($http, $q, $stateParams) {
						return $stateParams.id_report;
					}
				},
				views: {
					'menuContent': {
						templateUrl: 'templates/payments.html',
						controller: 'ReportCtrl'

					}
				}
			})
			//Scheme detailed view
			.state('app.viewscheme', {
				url: '/viewscheme/:id_scheme',
				cache: false,
				resolve: {
					schemeID: function ($http, $q, $stateParams) {
						return $stateParams.id_scheme;
					}
				},
				views: {
					'menuContent': {
						templateUrl: 'templates/viewscheme_detail.html',
						controller: 'SchemeDetailCtrl'

					}
				}
			})

			//feedback
			.state('app.feedback', {
				url: "/feedback",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/feedback.html",
						controller: "FeedbackCtrl"
					}
				}

			})
			//vendor enquiry
			.state('app.vendor_enquiry', {
				url: "/vendor_enquiry",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/vendor_enquiry.html",
						controller: "AppCtrl"
					}
				}

			})


			//contact us
			.state('app.address', {
				url: "/address",
				views: {
					'menuContent': {
						templateUrl: "templates/contact.html",
						controller: "AppCtrl"
					}
				}

			})

			.state('app.contact', {
				url: "/contact",
				views: {
					'menuContent': {
						templateUrl: "templates/contact.html",
						controller: "AppCtrl"
					}
				}

			})
			/*** Static pages ***/
			//about us
			.state('app.about', {
				url: "/about",
				views: {
					'menuContent': {
						templateUrl: "templates/aboutus.html"
					}
				}

			})

			//terms
			.state('app.terms', {
				url: "/terms",
				views: {
					'menuContent': {
						templateUrl: "templates/terms.html",
						controller: "TermsCtrl"
					}
				}

			})

			//terms
			.state('app.generalterms', {
				url: "/generalterms",
				views: {
					'menuContent': {
						templateUrl: "templates/general-terms.html",
						controller: "commonCtrl"
					}
				}

			})

			//privacy
			.state('app.privacy', {
				url: "/privacy",
				views: {
					'menuContent': {
						templateUrl: "templates/privacy.html",
						controller: "commonCtrl"
					}
				}

			})

			//faq
			.state('app.faq', {
				url: "/faq",
				views: {
					'menuContent': {
						templateUrl: "templates/faq.html",
						controller: "commonCtrl"
					}
				}

			})

			//scheme classification
			.state('app.schemeclsfy', {
				url: "/schemeclsfy",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/schemeClassification.html",
						controller: "SavingSchemeCtrl"
					}
				}

			})

			//saving scheme

			.state('app.savingscheme', {
				url: '/savingscheme/:id_classification/:cls_name',
				//params: { schemes: null },
				views: {
					'menuContent': {
						templateUrl: 'templates/savingscheme.html',
						controller: 'schemesListCtrl'

					}
				}
			})

			//New arrivals
			.state('app.newarrivals', {
				url: "/newarrivals",
				views: {
					'menuContent': {
						templateUrl: "templates/newarrivals.html",
						controller: "NewArrivalsCtrl"
					}
				}

			})
			//gift items
			.state('app.giftitems', {
				url: "/giftitems",
				views: {
					'menuContent': {
						templateUrl: "templates/giftitems.html",
						controller: "GiftItemsCtrl"
					}
				}

			})
			//gift items details
			.state('app.giftitems_detail', {
				url: "/giftitems_detail",
				views: {
					'menuContent': {
						templateUrl: "templates/giftitems_detail.html",
						controller: "GiftItemsCtrl"
					}
				}

			})

			//offers
			.state('app.offers', {
				url: "/offers",
				views: {
					'menuContent': {
						templateUrl: "templates/offers.html",
						controller: "OffersCtrl"
					}
				}

			})


			//New arrivals
			.state('app.offerdetail', {
				url: "/offerdetail",
				views: {
					'menuContent': {
						templateUrl: "templates/offer_detail.html",
						controller: "OffersCtrl"
					}
				}

			})

			//New arrivals
			.state('app.newarrivaldetail', {
				url: "/newarrivaldetail",
				views: {
					'menuContent': {
						templateUrl: "templates/newarrivals_detail.html",
						controller: "NewArrivalsCtrl"
					}
				}

			})
			//closed Acc
			.state('app.colsedaccounts', {
				url: '/colsedaccounts',
				views: {
					'menuContent': {
						templateUrl: 'templates/myclosedschemes.html',
						controller: 'cosedAccCtrl'
					}
				}
			})

			.state('app.payview', {
				url: "/payview",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/payview.html",
						controller: "payOptionsCtrl",
						reload: true
					}
				}
			})

			.state('app.cards', {
				url: '/cards',
				views: {
					'menuContent': {
						templateUrl: 'templates/cardmodal.html',
						controller: 'payOptionsCtrl'
					}
				}
			})

			.state('app.paycvv', {
				url: "/paycvv",
				cache: false,
				//	params : { cardDetail : null},
				views: {
					'menuContent': {
						templateUrl: "templates/paycvv.html",
						controller: "GatewayCtrl",
						reload: true
					}
				}
			})

			//credit card
			.state('app.creditcard', {
				url: '/creditcard',
				params: { gateway: null, showSaveOption: null },
				views: {
					'menuContent': {
						templateUrl: 'templates/creditcard.html',
						controller: 'GatewayCtrl'
					}
				}
			})

			//debit card
			.state('app.debitcard', {
				url: '/debitcard',
				params: { gateway: null, showSaveOption: null },
				views: {
					'menuContent': {
						templateUrl: 'templates/debitcard.html',
						controller: 'GatewayCtrl'
					}
				}
			})

			//netbanking
			.state('app.netbanking', {
				url: "/netbanking",
				params: { nbData: null },
				views: {
					'menuContent': {
						templateUrl: 'templates/netbanking.html',
						controller: 'GatewayCtrl'
					}
				}
			})

			.state('app.savedCards', {
				url: "/savedCards",
				cache: false,
				views: {
					'menuContent': {
						templateUrl: "templates/savedCards.html",
						controller: "savedCardCtrl"
					}
				}

			})

			.state('maintenance', {
				url: "/maintenance",
				params: { text: null, comp: null },
				templateUrl: "templates/maintenance.html",
				controller: "NavCtrl"
			})

			//check maintenance mode , popup , version
			.state('check_m', {
				url: "/check_m",
				controller: "CheckCtrl"
			})

			.state('app.scheme_reg_req', {
				url: '/scheme_reg_req',
				views: {
					'menuContent': {
						templateUrl: 'templates/existingRegReqests.html',
						controller: 'ExistingRegReqCtrl'
					}
				}
			})

			.state('app.choose', {
				url: '/choose',
				views: {
					'menuContent': {
						templateUrl: 'templates/choose.html',
						controller: "Choosectrl"
					}
				},
				authStatus: false
			})



			//showroomctrl
			.state('app.showroom_img', {
				url: "/showroom_img",
				views: {
					'menuContent': {
						templateUrl: "templates/showroom_img.html",
						controller: 'ShowroomCtrl'
					}
				}

			})

			//Catalog
			.state('app.categoryList', {
				url: "/categoryList",
				views: {
					'menuContent': {
						templateUrl: "templates/categoryList.html",
						controller: "CategoryCtrl"
					}
				}
			})
			//Catalog
			.state('app.collections', {
				url: "/collections/:id_category",
				params: { sub_category: null },
				views: {
					'menuContent': {
						templateUrl: "templates/collections.html",
						controller: "subcategoryCtrl"
					}
				}

			})

			//productdetail
			.state('app.productdetail', {
				url: "/productdetail",
				params: { productId: null },
				views: {
					'menuContent': {
						templateUrl: "templates/productdetail.html",
						controller: "productDetailCtrl"
					}
				}

			})

		// if none of the above states are matched, use this as the fallback
		$urlRouterProvider.otherwise('/check_m');
	//	$urlRouterProvider.otherwise('/app/home');
	});



