angular
	.module("winchit.controllers", [])

	.controller("AppCtrl", function ($scope, $ionicModal, $ionicPopover, $timeout, $location, $ionicPopup, $ionicSideMenuDelegate, $ionicLoading, generalService, $localstorage, $window, $state, $cordovaToast, $rootScope, checkInternet, $ionicHistory) {
		$scope.feedbackData = [];
		$scope.enquiryData = [];


		// With the new view caching in Ionic, Controllers are only called
		// when they are recreated or on app start, instead of every page change.
		// To listen for when this page is active (for example, to refresh data),
		// listen for the $ionicView.enter event:

		$scope.settings = [];
		$scope.go = function (path) {
			$location.path(path);
		};

		$scope.login = [];
		$scope.login = function (path) {
			$ionicHistory.nextViewOptions({
				disableBack: true
			});
			$location.path(path);
		};

		$scope.join_new = function () {
			$window.location.href = "#/app/schemeclsfy";
		};

		$scope.reg_existing = function () {
			$window.location.href = "#/app/existingscheme/1/''/''/''";
		};

		$scope.customer_supp = function () {
			$window.location.href = "#/app/customersupport";
		};

		$scope.select_payment = function () {
			$window.location.href = "#/app/paydues";
		};

		$scope.$on("$ionicView.enter", function (e) {
			// $ionicHistory.nextViewOptions({
			// 	disableBack: true
			// });
			$scope.companyName = generalService.companyName;
			var haveInternet = checkInternet();
			if (haveInternet == true) {
				$scope.errormsg = "";
			} else {
				$ionicLoading.hide();
				$cordovaToast.show("No Internet connection..", "long", "center").then(
					function (success) {
						// success
					},
					function (error) {
						// error
					}
				);
			}

			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;

			generalService.getCurrency().then(function (result) {
				if (result.data) {
					$scope.currency = result.data.currency;
					$scope.metalrate = result.data.metal_rates;
					generalService.currency = $scope.currency;
					generalService.metalrate = $scope.metalrate;
				} else {
					$scope.errormsg = "";
				}
				$ionicLoading.hide();
			});

			// Form data for the login modal
			$scope.loginData = {};
			$scope.userData = [];
			$scope.userData = generalService.userData;
			$scope.loginData = generalService.loginData;
			if ($scope.userData.logged != 1) {
				var post = $localstorage.getObject("logincred");

				if (post !== undefined && post.rememberme === true) {
					$scope.user = post;

					var postData = {
						mobile: post.mobile,
						passwd: post.passwd,
						token: generalService.deviceRegData.token,
						uuid: generalService.deviceRegData.uuid,
						device_type: generalService.deviceRegData.device_type
					};
					generalService.authenticate(postData).then(function (result) {
						if (result.data.is_valid) {
							$scope.userData = {
								logged: 1,
								mobile: post.mobile,
								accounts: result.data.accounts,
								payments: result.data.payments,
								wallet: result.data.wallet,
								profile: result.data.customer,
								notification: result.data.notification
							};
							$scope.loginData = {
								mobile: post.mobile,
								passwd: post.passwd,
								rememberme: 1
							};
							generalService.userData = $scope.userData;
							generalService.loginData = $scope.loginData;
							$rootScope.$broadcast("UpdateDashboard", $scope.userData);
							$window.location.href = "#/app/home";
						} else {
							//  $scope.errormsg = "Unable to Login! Please contact customer care";
						}
						/* $ionicLoading.hide();	*/
					});
				} else {
					$scope.loginData = {};
					/* $ionicLoading.hide();*/
				}
			}
		});

		// Set the default value of inputType
		$scope.LogininputType = "password";
		// Hide & show password function
		$scope.hideShowPassword = function () {
			if ($scope.LogininputType == "password") {
				$scope.LogininputType = "text";
			}
			else {
				$scope.LogininputType = "password";
			}
		};

		//left menu
		$scope.toggleLeft = function () {
			$ionicSideMenuDelegate.toggleLeft();
		};
		//--------------------------------------------
		$scope.signIn = function (form) {
			$scope.authData = [];
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if (form.$valid) {
				console.log(generalService.deviceRegData);
				$scope.authData = {
					mobile: $scope.loginData.mobile,
					passwd: $scope.loginData.passwd,
					token: generalService.deviceRegData.token,
					uuid: generalService.deviceRegData.uuid,
					device_type: generalService.deviceRegData.device_type
				};
				//call service for authentication
				generalService.authenticate($scope.authData).then(function (result) {
					//if data fetched

					if (result.status == "200") {
						$ionicLoading.hide();
						console.log(result.data);
						if (result.data.is_valid) {
							$scope.userData = {
								logged: 1,
								mobile: $scope.loginData.mobile,
								accounts: result.data.accounts,
								payments: result.data.payments,
								wallet: result.data.wallet,
								profile: result.data.customer,
								notification: result.data.notification
							};

							//for remember passwd

							if ($scope.loginData.rememberme) {
								$localstorage.setObject("logincred", {
									mobile: $scope.loginData.mobile,
									passwd: $scope.loginData.passwd,
									rememberme: $scope.loginData.rememberme,
									token: generalService.deviceRegData.token,
									uuid: generalService.deviceRegData.uuid,
									device_type: generalService.deviceRegData.device_type
								});
							} else {
								var logincred = $localstorage.getObject("logincred");
								if (typeof logincred != undefined) {
									$localstorage.setObject("logincred", "");
								}
							}

							//passing variables to service variables
							generalService.userData = $scope.userData;
							generalService.loginData = $scope.loginData;
							console.log($scope.userData);
							$scope.errormsg = "";
							$location.path("/app/home");
						} else {
							$cordovaToast
								.show("Invalid username or password..", "long", "center")
								.then(
									function (success) {
										// success
									},
									function (error) {
										// error
									}
								);
							/*$scope.showAlert('Invalid username or password.');	*/
						}
					} else {
						$ionicLoading.hide();
						//Incase of network or server error
						$cordovaToast
							.show("Check network connection", "long", "center")
							.then(
								function (success) {
									// success
								},
								function (error) {
									// error
								}
							);
						/*$scope.showAlert('Check network connection');*/
					}
				});
			} else {
				$ionicLoading.hide();
				/*toast*/
				$cordovaToast.show("Enter valid credentials", "long", "center").then(
					function (success) {
						// success
					},
					function (error) {
						// error
					}
				);
				/*end of toast*/
			}
		};
		//--------------------------------------------
		//$scope.logout = function() {   $location.path('/app/login');   };

		$scope.logout = function () {
			var confirmPopup = $ionicPopup.confirm({
				title: "Confirm Logout",
				template: "Are you sure you want to logout"
			});

			confirmPopup.then(function (res) {
				if (res) {
					var logincred = $localstorage.getObject("logincred");
					if (logincred != undefined) {
						$localstorage.setObject("logincred", "");
					}

					$scope.userData = {
						logged: 0
					};
					generalService.userData = $scope.userData;
					//$scope.loginData.accounts;=0;
					$window.location.href = "#/app/login";
				} else {
					$window.location.href = "#/app/home";
				}
			});
		};

		/* 		//select schemes existing or new
					$scope.select_scheme = function () {
						$window.location.href = "#/app/select_scheme";
					}
	
					//send feedback
					$scope.send_feedback = function (form) {
						 $scope.user=[];
						 $scope.userData =[];
	
						 generalService.userData = $scope.userData
	
						 if ($scope.userData.logged == 1) {
							$scope.userData.firstname = $scope.userData.profile.firstname;
							$scope.userData.lastname = $scope.userData.profile.lastname;
							$scope.userData.email = $scope.userData.profile.email;
							$scope.userData.mobile = $scope.userData.profile.mobile;
						}
	
	
						if (form.$valid) {
							$ionicLoading.show({
								content: 'Loading',
								template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
								showBackdrop: true,
								maxWidth: 200,
								showDelay: 0
							});
							console.log($scope.feedbackData);
							generalService.sendFeedback($scope.feedbackData).then(function (result) {
								// console.log(result.data);
								$ionicLoading.hide();
								var alertPopup = $ionicPopup.alert({
									title: 'Feedback',
									template: "Feedback send successfully"
								});
	
							//	 .popup-head{ background-color : blue; }
								//	  .popup-body{ background-color : red; }
	
								alertPopup.then(function (res) {
									$scope.feedbackData = '';
									$window.location.href = "#/app/home";
								});
							})
						}
					} */

		//send feedback
		$scope.vendor_enquiry = function (form) {
			if (form.$valid) {
				$scope.input_error = '';

				// Validate ac name	
				var nameRegexp = /^[a-zA-Z ]*$/;
				var acname = $scope.enquiryData.customer_name;
				var txt = acname.toUpperCase();
				if (!nameRegexp.test(txt)) {
					$validAc = false;
					$scope.input_error = $scope.input_error + " Account name must contain alphabets only. ";
				} else {
					$validAc = true;
				}

				if ($validAc) {
					$ionicLoading.show({
						content: "Loading",
						template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
						showBackdrop: true,
						maxWidth: 200,
						showDelay: 0
					});
					console.log($scope.enquiryData);
					generalService.sendVendorEnquiry($scope.enquiryData).then(function (result) {
						$ionicLoading.hide();
						var alertPopup = $ionicPopup.alert({
							title: "Vendor Enquiry",
							template: "Enquiry sent successfully"
						});
						alertPopup.then(function (res) {
							$scope.enquiryData = "";
							$window.location.href = "#/app/home";
						});
					});
				}
				$ionicLoading.hide();
			} else {

				if (form.customer_name.$invalid) {
					$cordovaToast.show("Cutomer Name is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
				else if (form.company_name.$invalid) {
					$cordovaToast.show("Company Name is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
				else if (form.mobile_no.$invalid) {
					$cordovaToast.show("Mobile No is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
				else if (form.email_id.$invalid) {
					$cordovaToast.show("Mobile No is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
				else if (form.reg.$invalid) {
					$cordovaToast.show("Nature of Work is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
				else if (form.comments.$invalid) {
					$cordovaToast.show("Comments is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
				else {
					$ionicLoading.hide();
				}

			}


		};

		//--------------------------------------------
		// An alert dialog
		$scope.showAlert = function (msg) {
			var alertPopup = $ionicPopup.alert({
				title: "Warning !",
				template: msg
			});
		};
		//--------------------------------------------
	})

	//Register
	.controller("FeedbackCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $localstorage, $ionicPlatform, $cordovaToast, $ionicLoading, $stateParams) {
		$scope.$on("$ionicView.enter", function (e) {
			$scope.feedbackData = [];
			$scope.userData = [];
			$scope.userData = generalService.userData;
			$scope.feedbackData = generalService.userData.profile;
			//	alert(JSON.stringify($scope.feedbackData));
			if ($scope.userData.logged == 1) {
				$scope.feedbackData.firstname = $scope.userData.profile.firstname;
				$scope.feedbackData.lastname = $scope.userData.profile.lastname;
				$scope.feedbackData.mobile = $scope.userData.mobile;
				$scope.feedbackData.email = $scope.userData.profile.email;
			}
		});

		//customer register
		$scope.send_feedback = function (form) {

			if (form.$valid) {

				var allow_submit = false;
				var regexp = /^[a-zA-Z ]*$/;
				var firstname = $scope.userData.profile.firstname;
				var lastname = $scope.userData.profile.lastname;

				var txt = firstname.toUpperCase();
				if (!regexp.test(txt)) {
					ltxt = lastname.toUpperCase();
					if (!regexp.test(ltxt)) {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							template: 'Firstname and lastname must contain alphabets only',
							cssClass: 'my-custom-popup',
						});
						allow_submit = false;
					} else {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							template: 'Firstname must contain alphabets only',
							cssClass: 'my-custom-popup',
						});
						allow_submit = false;
					}
				} else {
					var txt = lastname.toUpperCase();
					if (!regexp.test(txt)) {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							template: 'Lastname must contain alphabets only',
							cssClass: 'my-custom-popup',
						});
						allow_submit = false;
					} else {
						allow_submit = true;
					}
				}


				if (allow_submit) {
					console.log("validaton success");
					$ionicLoading.show({
						content: "Loading",
						template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
						showBackdrop: true,
						maxWidth: 200,
						showDelay: 0
					});
					console.log($scope.feedbackData);
					$scope.feedbackData = {
						'reg': $scope.feedbackData.reg,
						'message': $scope.feedbackData.comments,
						'email': $scope.userData.profile.email,
						'mobile': $scope.userData.mobile,
						'firstname': $scope.userData.profile.firstname,
						'lastname': $scope.userData.profile.lastname,
						'address': $scope.feedbackData.address,
						};
					//alert('feedback data : ' + JSON.stringify($scope.feedbackData));

					generalService.sendFeedback($scope.feedbackData).then(function (result) {
						//alert("data's " + JSON.stringify(result));
						console.log(result);
						$ionicLoading.hide();
						/* $cordovaToast
						.show('Thanks for your valuable feedback', '6000', 'center')
						.then(function (success) {
						  // success
						}, function (error) {
						  // error
						}); */

						var alertPopup = $ionicPopup.alert({
							title: "FeedBack",
							template: "Feedback sent successfully",
							cssClass: 'feedback-popup'
						});

						alertPopup.then(function (res) {
							//  $cordovaToast.show("Thanks for your valuable feedback", "3000", "center")
							$window.location.href = "#/app/home";


						});
					});
				}
				$ionicLoading.hide();
			}
			else {
				console.log(form.$invalid);
				//disable loading
				$ionicLoading.hide();
				if (form.firstname.$invalid) {
					$cordovaToast.show("firstname is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.lastname.$invalid) {
					$cordovaToast.show("lastname is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);

				}
				else if (form.mobile.$invalid) {
					$cordovaToast.show("Mobile no is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);

				}
				else if (form.email.$invalid) {
					$cordovaToast.show("Email is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);

				} else if (form.address.$invalid) {
					$cordovaToast.show("address is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.profession.$invalid) {
					$cordovaToast.show("profession is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.date_of_birth.$invalid) {
					$cordovaToast.show("Date of birth is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.reg.$invalid) {
					$cordovaToast.show("select any one", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.comments.$invalid) {
					$cordovaToast.show("Write your comments", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else {
					$cordovaToast.show("Fill the message", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
			}
		};
	})

	// common pages Ctrl
	.controller("commonCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location) {
		$scope.companyName = generalService.companyName;
		$scope.co_company = generalService.co_company;
	})

	//Closed Acc ctrl
	.controller("cosedAccCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location) {
		$scope.$on("$ionicView.enter", function (e) {
			$scope.currency = generalService.currency;
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if (generalService.userData.logged == 1) {
				generalService.closedAcc().then(function (result) {
					if (result.data) {
						$scope.closedAcc = result.data.closed_acc;
						console.log($scope.closedAcc);
						if (result.data.msg != null) {
							$scope.errormsg = result.data.msg;
						}
					}
					$ionicLoading.hide();
				});
			} else {
				$ionicLoading.hide();
				$window.location.href = "#/app/login";
			}
		});
	})
	//Home
	.controller("HomeCtrl", function ($scope, $ionicHistory, generalService, $http, $window, $state, $ionicLoading, $ionicSlideBoxDelegate, $timeout, $location, $rootScope, $ionicScrollDelegate, $ImageCacheFactory, $ionicPopup, $cordovaToast, $ImageCacheFactory, $cordovaActionSheet) {
		$scope.metalrate = [];
		$scope.currency = [];
		$scope.offers = [];
		$scope.user = [];
		$scope.dash = [];
		$scope.name = [];


		// Comming Soon...
		$scope.checkflag = function (type) {
			if (generalService.dashboardData.showcomingsoon == 1) {
				$cordovaToast.show("Coming Soon", "long", "center");
			} else {
				if (type == "m") {
					$window.location.href = "#/app/myschemes/s";
				} else if (type == "d") {
					$window.location.href = "#/app/paydues";
				} else if (type == "h") {
					$window.location.href = "#/app/payments/p";
				}
			}
		};

		$rootScope.$on("UpdateDashboard", function (event, message) {



			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});



			generalService.getCustomerDashboard().then(function (result) {

				$scope.showDash = 1;
				$scope.dash = result.data;
				generalService.dashboardData = result.data;

				//userdata
				$scope.user = result.data.customer;
				$scope.user.name = {
					name: $scope.user.firstname + " " + $scope.user.lastname,
					first: $scope.user.firstname,
					last: $scope.user.lastname
				};
				$ionicLoading.hide();
			});
		});

		generalService.getoffers().then(function (result) {
			if (result.data) {
				$scope.offers_banners = result.data.offers_banners;
				$scope.offers = result.data.offers;
				generalService.offers = result.data.offers;
				$ionicSlideBoxDelegate.update();
				$ionicSlideBoxDelegate.$getByHandle("image-viewer").update();

				//Build the list of images to preload
				var sliderimages = [];
				for (var i = 0; i < result.data.offers_banners.length; i++) {
					sliderimages.push(result.data.offers_banners[i].offer_img_path);
				}
				$ImageCacheFactory.Cache(sliderimages);
				//console.log(offerimages);
			}
		});

		generalService.newArrivals().then(function (result) {
			if (result.data) {
				$scope.new_arrivals = result.data.new_arrivals;
				generalService.new_arrivals = $scope.new_arrivals;

				//Build the list of images to preload
				var newarrimages = [];
				for (var i = 0; i < result.data.new_arrivals.length; i++) {
					newarrimages.push(result.data.new_arrivals[i].new_arrivals_img_path);
				}
				$ImageCacheFactory.Cache(newarrimages);
				//console.log(offerimages);
			}
		});

		generalService.giftItems().then(function (result) {
			if (result.data) {
				$scope.gift_items = result.data.gift_items;
				generalService.gift_items = $scope.gift_items;
				//  console.log('gift : '+JSON.stringify(generalService.gift_items));

				//Build the list of images to preload
				var giftarrimages = [];
				for (var i = 0; i < result.data.gift_items.length; i++) {
					giftarrimages.push(result.data.gift_items[i].new_arrivals_img_path);
				}
				$ImageCacheFactory.Cache(giftarrimages);
				//console.log(offerimages);
			}
		});

		$scope.$on("$ionicView.enter", function (e) {
			$scope.showDash = false;
			$scope.loginstatus = generalService.userData.logged;
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			//load currency/settings details
			generalService.getCurrency().then(function (result) {
				if (result.data) {
					$scope.currency = result.data.currency;
					$scope.metalrate = result.data.metal_rates;
					generalService.currency = $scope.currency;
					generalService.metalrate = $scope.metalrate;
				} else {
					$scope.errormsg = "";
				}
				$ionicLoading.hide();
			});
			if ($scope.loginstatus == 1) {

				/*      Notification popup worked...         
				
						$scope.cusnotification = [];
						$scope.data = [];
						$scope.data.wcNotiNeverAsk = false;
						let donotShotpopup = (localStorage.getItem("wcNotiNeverAsk") !== null ? JSON.parse(localStorage.getItem("wcNotiNeverAsk")) : 0);
					    
						if (donotShotpopup == 0 && generalService.userData.notification == 0) {
						  var customTemplate = '<ion-toggle ng-model="data.wcNotiNeverAsk">Never ask again</ion-toggle>';
				
							var myPopup = $ionicPopup.show({
							  title: 'Notification',
							  subTitle: '',
							  scope: $scope,
							  template: customTemplate ,
							  message: '',
							  buttons: [
								{
								  text: 'No',
								  onTap: function (e) {
									let neverAskFlag = ($scope.data.wcNotiNeverAsk == true ? 1 : 0);
									localStorage.setItem("wcNotiNeverAsk", JSON.stringify(neverAskFlag));
									return false;
								  }
								},
								{
								  text: '<b>Yes</b>',
								  type: 'button-positive',
								  onTap: function (e) {
									let neverAskFlag = ($scope.data.wcNotiNeverAsk == true ? 1 : 0);
									localStorage.setItem("wcNotiNeverAsk", JSON.stringify(neverAskFlag));
									return true;
								  }
								}
							  ]
							});
				
							myPopup.then(function (res) {
							  console.log(res);
							  if (res) {
								// call enable noti api here 
								var notification = 1;
								var postData = {
								  id_customer: $scope.userData.profile.id_customer,
								  notification: 1,
								  token: generalService.deviceRegData.token,
								  uuid: generalService.deviceRegData.uuid,
								  device_type: generalService.deviceRegData.device_type
								};
								$ionicLoading.show();
								generalService.updatenotiSettings(postData).then(function (result) {
								  if (result.data.status == true) { 
									generalService.userData.notification = notification;
					  //   alert(generalService.userData.notification);
									$ionicLoading.hide();
								  } else {
									$ionicLoading.hide();
									$scope.errormsg = "";
									$cordovaToast.show("Something went wrong,try again later..", "long", "center").then(
										function (success) {
										  // success
										},
										function (error) {
										  // error
										}
									  );
								  }
								});
							  }
							});
						}
				 */
				$scope.showDash = 1;
				generalService.getCustomerDashboard().then(function (result) {
					$scope.dash = result.data;
					generalService.dashboardData = result.data;

					$scope.user = result.data.customer;
					$scope.user.name = {
						name: $scope.user.firstname + " " + $scope.user.lastname,
						first: $scope.user.firstname,
						last: $scope.user.lastname
					};
					$ionicLoading.hide();
				});
			} else {
				$scope.showDash = 0;
			}

			$ionicLoading.hide();
		});
		//slide
		$scope.next = function () {
			$ionicSlideBoxDelegate.next();
		};

		$scope.previous = function () {
			$ionicSlideBoxDelegate.previous();
		};

		$scope.slideChanged = function (index) {
			$scope.slideIndex = index;
			if ($scope.offers_banners != undefined) {
				if ($scope.offers_banners.length - 1 == index) {
					$timeout(function () {
						$ionicSlideBoxDelegate.slide(0);
						$scope.slideIndex = 0;
					}, 4000);
				}
			}
		};
	})

	//Home
	.controller("Choosectrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $ionicSlideBoxDelegate, $timeout, $location, $rootScope, $ionicScrollDelegate, $ImageCacheFactory, $ionicPopup, $cordovaToast, $ionicHistory) {
		$scope.metalrate = [];
		$scope.currency = [];
		$scope.offers = [];
		$scope.user = [];
		$scope.dash = [];
		$scope.name = [];

		// Comming Soon...
		$scope.checkflag = function (type) {
			if (generalService.dashboardData.showcomingsoon == 1) {
				$cordovaToast.show("Coming Soon", "long", "center");
			} else {
				if (type == "m") {
					$window.location.href = "#/app/myschemes/s";
				} else if (type == "d") {
					$window.location.href = "#/app/paydues";
				} else if (type == "h") {
					$window.location.href = "#/app/payments/p";
				}
			}
		};

		$rootScope.$on("UpdateDashboard", function (event, message) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			generalService.getCustomerDashboard().then(function (result) {
				$scope.showDash = 1;
				$scope.dash = result.data;
				generalService.dashboardData = result.data;

				//userdata
				$scope.user = result.data.customer;
				$scope.user.name = {
					name: $scope.user.firstname + " " + $scope.user.lastname,
					first: $scope.user.firstname,
					last: $scope.user.lastname
				};
				$ionicLoading.hide();
			});
		});

		generalService.getoffers().then(function (result) {
			if (result.data) {
				$scope.offers_banners = result.data.offers_banners;
				$scope.offers = result.data.offers;
				generalService.offers = result.data.offers;
				$ionicSlideBoxDelegate.update();
				$ionicSlideBoxDelegate.$getByHandle("image-viewer").update();

				//Build the list of images to preload
				var sliderimages = [];
				for (var i = 0; i < result.data.offers_banners.length; i++) {
					sliderimages.push(result.data.offers_banners[i].offer_img_path);
				}
				$ImageCacheFactory.Cache(sliderimages);
				//console.log(offerimages);
			}
		});

		generalService.newArrivals().then(function (result) {
			if (result.data) {
				$scope.new_arrivals = result.data.new_arrivals;
				generalService.new_arrivals = $scope.new_arrivals;

				//Build the list of images to preload
				var newarrimages = [];
				for (var i = 0; i < result.data.new_arrivals.length; i++) {
					newarrimages.push(result.data.new_arrivals[i].new_arrivals_img_path);
				}
				$ImageCacheFactory.Cache(newarrimages);
				//console.log(offerimages);
			}
		});

		generalService.giftItems().then(function (result) {
			if (result.data) {
				$scope.gift_items = result.data.gift_items;
				generalService.gift_items = $scope.gift_items;
				//  console.log('gift : '+JSON.stringify(generalService.gift_items));

				//Build the list of images to preload
				var giftarrimages = [];
				for (var i = 0; i < result.data.gift_items.length; i++) {
					giftarrimages.push(result.data.gift_items[i].new_arrivals_img_path);
				}
				$ImageCacheFactory.Cache(giftarrimages);
				//console.log(offerimages);
			}
		});

		$scope.$on("$ionicView.enter", function (e) {
			$ionicHistory.nextViewOptions({
				disableBack: true
			});

			$scope.showDash = false;
			$scope.loginstatus = generalService.userData.logged;
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			//load currency/settings details
			generalService.getCurrency().then(function (result) {
				if (result.data) {
					$scope.currency = result.data.currency;
					$scope.metalrate = result.data.metal_rates;
					generalService.currency = $scope.currency;
					generalService.metalrate = $scope.metalrate;
				} else {
					$scope.errormsg = "";
				}
				$ionicLoading.hide();
			});
			if ($scope.loginstatus == 1) {
				$scope.showDash = 1;
				generalService.getCustomerDashboard().then(function (result) {
					$scope.dash = result.data;
					generalService.dashboardData = result.data;

					$scope.user = result.data.customer;
					$scope.user.name = {
						name: $scope.user.firstname + " " + $scope.user.lastname,
						first: $scope.user.firstname,
						last: $scope.user.lastname
					};
					$ionicLoading.hide();
				});
			} else {
				$scope.showDash = 0;
			}

			$ionicLoading.hide();
		});
		//slide
		$scope.next = function () {
			$ionicSlideBoxDelegate.next();
		};

		$scope.previous = function () {
			$ionicSlideBoxDelegate.previous();
		};

		$scope.slideChanged = function (index) {
			$scope.slideIndex = index;
			if ($scope.offers != undefined) {
				if ($scope.offers.length - 1 == index) {
					$timeout(function () {
						$ionicSlideBoxDelegate.slide(0);
						$scope.slideIndex = 0;
					}, 4000);
				}
			}
		};
	})

	//Offers
	.controller("OffersCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal) {
		$scope.offdetail = [];
		$scope.offdetail = generalService.offdetail;
		$scope.view_off_details = function (id) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			console.log(id);
			generalService.offerDetail(id).then(function (result) {
				$ionicLoading.hide();
				if (result.data) {
					$scope.offdetail = result.data;
					generalService.offdetail = $scope.offdetail;
					$location.path("/app/offerdetail");
				} else {
					$scope.errormsg = "";
				}
			});
		};
		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};
		$scope.zoomImage = function () {
			$scope.showModal("templates/imageZoomView.html");
		};

		$scope.showModal = function (templateUrl) {
			$ionicModal
				.fromTemplateUrl(templateUrl, {
					scope: $scope,
					animation: "slide-in-up"
				})
				.then(function (modal) {
					$scope.modal = modal;
					$scope.type = 4;
					$scope.modal.show();
				});
		};

		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.offers = generalService.offers;
			console.log($scope.offers);
			if ($scope.offers.length == 0) {
				$scope.errormsg = "Currently there are no events.";
			}
			$ionicLoading.hide();
		});
	})

	// change or reset password

	.controller("changepwdCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal, $cordovaToast, $localstorage) {
		$scope.user = [];

		//forget passwd
		$scope.changepwd = function (form) {
			generalService.otpData = "";

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			if (form.$valid) {
				generalService.checkMobileReg($scope.user.mobile).then(function (result) {
					$ionicLoading.hide();
					if (result.data.is_reg) {
						generalService.otpData = {
							type: "reset",
							userdata: $scope.user
						};
						$window.location.href = "#/app/otp";
					} else {
						/*$scope.showAlert('Mobile number entered is not registered.');	*/
						$cordovaToast
							.show(
								"Mobile number entered is not registered.",
								"long",
								"center"
							)
							.then(
								function (success) {
									// success
								},
								function (error) {
									// error
								}
							);
					}
				});
			} else {
				$ionicLoading.hide();
			}
			if (form.mobile.$invalid) {
				$cordovaToast
					.show("Enter a valid mobile number", "long", "center")
					.then(
						function (success) { },
						function (error) {
							// error
						}
					);
			}
		};

		// forget password change

		$scope.resetpassword = function (form) {
			var usermobile = generalService.otpData.userdata.mobile;

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			if (form.$valid) {
				generalService.otpData = "";
				var cusData = {
					mobile: usermobile,
					passwd: $scope.user.passwd
				};

				//forgetpasswd
				generalService.updateCustomerByMobile(cusData).then(function (updatepwd) {
					$ionicLoading.hide();
					//clearing  variables
					$scope.rcvdData = "";
					$scope.user = "";
					generalService.otpData = "";

					//stopping sms watcher

					if (updatepwd.data.status == true) {
						$localstorage.setObject("logincred", {
							mobile: usermobile,
							passwd: cusData.passwd,
							rememberme: true
						});

						/* 	if (SMS) SMS.stopWatch(function () {
						  console.log('watching stopped');
						}, function () {
						  console.log('failed to stop watching');
						}); */

						$window.location.href = "#/app/home";
					} else {
						$cordovaToast.show(updatepwd.data.msg, "long", "top").then(
							function (success) {
								success;
							},
							function (error) {
								error;
							}
						);
					}
				});
			} else {
				$ionicLoading.hide();
			}

		};

		/*     $scope.ForgetinputType = 'password';
			// Hide & show password function
			$scope.pwdhideshow = function () {
			  if ($scope.ForgetinputType == 'password') {
				$scope.ForgetinputType = 'text';
			  } else {
				$scope.ForgetinputType = 'password';
			  }
			};
	    
			$scope.cninputType = 'password';
			$scope.cpwdhideshow = function () {
			  if ($scope.cninputType == 'password') {
				$scope.cninputType = 'text';
			  } else {
				$scope.cninputType = 'password';
			  }
			};
		 */

		//change passwd after login
		$scope.resetpswd = function (form) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.errormsg = "";
			if (form.$valid) {
				$scope.user.id_customer = generalService.userData.profile.id_customer;
				console.log($scope.registration);
				generalService.updateCustomer($scope.user).then(function (updatepwd) {
					$ionicLoading.hide();
					if (updatepwd.data.status == true) {
						$scope.loginData.logged = 0;
						$scope.registration = "";

						$localstorage.setObject("logincred", {
							mobile: generalService.userData.profile.mobile,
							passwd: $scope.user.passwd,
							rememberme: true
						});

						$window.location.href = "#/app/home";
					} else {
						$cordovaToast.show(updatepwd.data.msg, "long", "top").then(
							function (success) {
								success;
							},
							function (error) {
								error;
							}
						);
					}
				});
			} else {
				$ionicLoading.hide();
			}
		};


		$scope.ResetinputType = 'password';
		// Hide & show password function
		$scope.pwdhideshow = function () {
			if ($scope.ResetinputType == 'password') {
				$scope.ResetinputType = 'text';
			} else {
				$scope.ResetinputType = 'password';
			}
		};

		$scope.cninputType = 'password';
		$scope.cpwdhideshow = function () {
			if ($scope.cninputType == 'password') {
				$scope.cninputType = 'text';
			} else {
				$scope.cninputType = 'password';
			}
		};


	})

	//New Arrivals
	.controller("NewArrivalsCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal) {
		//on load view
		$scope.new_arrivals = [];
		$scope.detail = generalService.detail;

		$scope.view_details = function (id) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			generalService.newArrivalsDetail(id).then(function (result) {
				if (result.data) {
					$scope.detail = result.data;
					generalService.detail = $scope.detail;
					$location.path("/app/newarrivaldetail");
				} else {
					$scope.errormsg = "";
				}
			});
		};

		$scope.zoomImage = function () {
			$scope.showModal("templates/imageZoomView.html");
		};

		$scope.showModal = function (templateUrl) {
			$ionicModal
				.fromTemplateUrl(templateUrl, {
					scope: $scope,
					animation: "slide-in-up"
				})
				.then(function (modal) {
					$scope.modal = modal;
					$scope.type = 2;
					$scope.modal.show();
				});
		};

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};
		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.new_arrivals = generalService.new_arrivals;
			if ($scope.new_arrivals.length == 0) {
				$scope.errormsg = "Currently new arrivals are not available";
			} else {
				$scope.errormsg = "";
			}

			$ionicLoading.hide();
		});
	})
	//Giftitems
	.controller("GiftItemsCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal) {
		//on load view
		$scope.gift_items = [];
		$scope.detail = generalService.detail;

		$scope.view_details = function (id) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			generalService.giftitemsArrivalDetail(id).then(function (result) {
				if (result.data) {
					$scope.detail = result.data.gift_items;
					generalService.detail = $scope.detail;
					$location.path("/app/giftitems_detail");
				} else {
					$scope.errormsg = "";
				}
			});
		};

		$scope.zoomImage = function () {
			$scope.showModal("templates/imageZoomView.html");
		};

		$scope.showModal = function (templateUrl) {
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: "slide-in-up"
			})
				.then(function (modal) {
					$scope.modal = modal;
					$scope.type = 3;
					$scope.modal.show();
				});
		};

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};
		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.gift_items = generalService.gift_items;
			if ($scope.gift_items.length == 0) {
				$scope.errormsg = "Currently gift items are not available";
			} else {
				$scope.errormsg = "";
			}
			$ionicLoading.hide();
		});
	})

	//Settings
	.controller("SettingsCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $cordovaToast, $cordovaCamera, $cordovaFile, $cordovaFileTransfer) {
		//on load view
		$scope.cusnotification = [];
		$scope.uploadedImage - [];

		$scope.cus_noti_settings = function () {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
			});
			var cusnoti = $scope.cusnotification.notification == 0 ? 1 : 0;
			var postData = {
				id_customer: $scope.userData.profile.id_customer,
				notification: cusnoti,
				token: generalService.deviceRegData.token,
				uuid: generalService.deviceRegData.uuid,
				device_type: generalService.deviceRegData.device_type
			};
			generalService.updatenotiSettings(postData).then(function (result) {
				if (result.data.status == true) {
					$scope.cusnotification.notification = cusnoti;
					generalService.userData.notification = cusnoti;
					$ionicLoading.hide();
				} else {
					$ionicLoading.hide();
					$scope.errormsg = "";
					$cordovaToast
						.show("Something went wrong,try again later..", "long", "center")
						.then(
							function (success) {
								// success
							},
							function (error) {
								// error
							}
						);
				}
			});
		};

		$scope.$on("$ionicView.enter", function (e) {
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			$scope.userData = generalService.userData;
			console.log($scope.userData);
			$scope.cusnotification.notification = generalService.userData.notification;

			$ionicLoading.show({
				content: "Loading",
				template: '<ion-spinner icon="crescent" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			//profile upload image
			generalService.getCustomerByMobile().then(function (result) {
				if (result.data) {
					$scope.uploadedImage = result.data.cus_img;
					//   alert(JSON.stringify(result.data.cus_img));
				} else {
					$ionicLoading.hide();
				}
			});

			$scope.Profileimg = generalService.img;
			$scope.uploadedImage = $scope.userData.profile.cus_img;
			$scope.errormsg = "";
			$scope.picData = [];
			$scope.baseurl = generalService.baseurl;
			$scope.date = new Date();

			$scope.data = {
				ImageURI: "Select Image"
			};

			$scope.getPhoto = function () {
				//	alert('get photo');
				var options = {
					quality: 50,
					destinationType: Camera.DestinationType.FILE_URI,
					sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
					allowEdit: true,
					encodingType: Camera.EncodingType.JPEG,
					targetWidth: 1024,
					targetHeight: 768,
					popoverOptions: CameraPopoverOptions,
					saveToPhotoAlbum: false,
					correctOrientation: true
				};
				$scope.sourceType = 2;
				uploadPicture(options);
			};

			$scope.takePhoto = function () {
				//alert('tk');
				var options = {
					quality: 50,
					destinationType: Camera.DestinationType.FILE_URI,
					sourceType: Camera.PictureSourceType.CAMERA,
					allowEdit: true,
					encodingType: Camera.EncodingType.JPEG,
					targetWidth: 1024,
					targetHeight: 768,
					popoverOptions: CameraPopoverOptions,
					saveToPhotoAlbum: false,
					correctOrientation: true
				};
				$scope.sourceType = 1;
				uploadPicture(options);
			};

			function uploadPicture(options) {
				$cordovaCamera.getPicture(options).then(
					function (sourcePath) {
						var currentName = sourcePath.replace(/^.*[\\\/]/, "");
						var sourceDirectory = sourcePath.substring(0, sourcePath.lastIndexOf("/") + 1);
						var sourceFileName = sourcePath.substring(sourcePath.lastIndexOf("/") + 1, sourcePath.length);
						sourceFileName = sourceFileName.split("?")[0];
						$cordovaFile.copyFile(sourceDirectory, sourceFileName, cordova.file.dataDirectory, sourceFileName).then(
							function (success) {
								$scope.uploadedImage = cordova.file.dataDirectory + sourceFileName;
								if (($scope.sourceType = 1)) {
									$cordovaCamera.cleanup().then(
										function () {
											//success callback
										},
										function (err) {
											console.log(err);
										}
									);
								}
								var id_customer = generalService.userData.profile.id_customer;
								var d = new Date();
								var n = d.getTime();
								var filename = n + ".jpg";

								var upoptions = {
									fileKey: "file",
									fileName: filename,
									chunkedMode: false,
									mimeType: "image/jpeg",
									params: {
										fileName: filename,
										id_customer: $scope.userData.profile.id_customer
									}
								};

								$cordovaFileTransfer.upload(encodeURI(generalService.baseurl + "index.php/mobile_api/uploadCusimage"), $scope.uploadedImage, upoptions).then(function (result) {
									$ionicLoading.hide();
									var my_Date = new Date();
									var res = JSON.parse(result.response);
									if (result.path != 'null' && result.path != '') {
										//  alert('1');
										$scope.uploadedImage = res.path + '?nocache=' + my_Date.getUTCSeconds();
										//   alert(JSON.stringify($scope.uploadedImage ));
									}
									console.log("res : " + res);
									console.log("up_imag: " + JSON.stringify($scope.uploadedImage));

									$cordovaToast.show("Image Updated Successfully", "long", "center")
										.then(
											function (success) {
												$state.go("app.home");
											},
											function (error) { }
										);
								},
									function (err) {
										//    result
										console.log("console err msg :" + JSON.stringify(err));
										$ionicLoading.hide();
										$cordovaToast.show("", "long", "center")
											.then(function (success) { }, function (error) { });
									},
									function (progress) {
										$ionicLoading.show({
											template: "Uploading to server..."
										});
									}
								);
							},
							function (error) {
								console.log(error);
							});
					},
					function (err) {
						console.log(err);
					}
				);
			}
		});
	})

	//sharing ctrl
	.controller('SharingCtrl', function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $cordovaSocialSharing, $ionicPlatform, $cordovaToast) {
		$scope.user = {};
		$scope.images = [];
		$scope.referal_message = "";

		$scope.share = function (t, referal_message) {
			$ionicLoading.show({
				content: 'Loading',
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if ($scope.referal_message != "") {
				if (t == 'w') {
					window.plugins.socialsharing.shareViaWhatsApp($scope.referal_message, '');
				}
				else if (t == 'f') {
					window.plugins.socialsharing.shareViaFacebook($scope.referal_message, '');
				}
				else if (t == 't') {
					window.plugins.socialsharing.shareViaTwitter($scope.referal_message, '');
				}
				else if (t == 'sms') {
					window.plugins.socialsharing.shareViaSMS($scope.referal_message, '');
				}
				else {
					var sub = 'Reg:' + $scope.companyName + ',' + 'Invite Referrals';
					window.plugins.socialsharing.shareViaEmail($scope.referal_message, sub, '');
				}
				$ionicLoading.hide();
				$window.location.href = "#/app/home";
			}
			console.log($scope.referal_message);
		}

		$scope.$on('$ionicView.enter', function (e) {
			$ionicLoading.show({
				content: 'Loading',
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			var id_customer = generalService.userData.profile.id_customer;
			var mobile = generalService.userData.mobile;
			var postData = {
				'mobile': mobile
			}

			generalService.referral_linksend(postData).then(function (result) {
				$scope.referal_message = "";
				if (result.data.status == true) {
					$scope.referal_message = result.data.message;
					$ionicLoading.hide();
				} else {
					$ionicLoading.hide();
					console.log('invalid');
				}
			})

		});

		$ionicLoading.hide();
	})

	//Customer support
	.controller("CustomerSuppCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location) {
		//on load view
		$scope.cusnotification = [];

		generalService.companyDetail().then(function (result) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner>',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if (result.data) {
				$scope.companyDetails = result.data;
				generalService.companyDetails = $scope.companyDetails;
			} else {
				$scope.errormsg = "";
			}
			$ionicLoading.hide();
		});
		$scope.facebook = function () {
			var customHeaders = "foo:123,bar:456";
			cordova.InAppBrowser.open("https://www.facebook.com/bhoopalamjewellery", "_blank", "location=yes,zoom=no,footer=yes,footercolor=#00ff00,hidenavigationbuttons=no,navigationbuttoncolor=#00ff00,closebuttoncolor=#00ff00", "closebuttoncaption=Back", customHeaders);
		};
		$scope.instagram = function () {
			var customHeaders = "foo:123,bar:456";
			cordova.InAppBrowser.open("https://www.instagram.com/cpljewellers/", "_blank", "location=yes,zoom=no,footer=yes,footercolor=#00ff00,hidenavigationbuttons=no,navigationbuttoncolor=#00ff00,closebuttoncolor=#00ff00", "closebuttoncaption=Back", customHeaders);
		};
/* 		$scope.rateus = function () {
			var customHeaders = "foo:123,bar:456";
			cordova.InAppBrowser.open("https://goo.gl/uc3m7Y", "_blank", "location=yes,zoom=no,footer=yes,footercolor=#00ff00,hidenavigationbuttons=no,navigationbuttoncolor=#00ff00,closebuttoncolor=#00ff00", "closebuttoncaption=Back", customHeaders);
		};

		$scope.carrierlocate = function () {
			var customHeaders = "foo:123,bar:456";
			cordova.InAppBrowser.open("https://www.challanijewels.com/index.php?controller=contact", "_blank", "location=yes,zoom=no,footer=yes,footercolor=#00ff00,hidenavigationbuttons=no,navigationbuttoncolor=#00ff00,closebuttoncolor=#00ff00", "closebuttoncaption=Back", customHeaders);
		}; */

	})

	//Register
	.controller("RegCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $localstorage, $ionicPlatform, $cordovaToast, $ionicLoading) {
		$scope.user = [];
		$scope.reg = [];
		$scope.rcvdOTP = {};

		//customer register
		$scope.register_customer = function (form) {
			$scope.form = {};

			generalService.otpData = "";
			//load spinner
			/*       $ionicLoading.show({
					content: "Loading",
					template:
					  'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
					showBackdrop: true,
					maxWidth: 200,
					showDelay: 0
				  });
			 */


			if (form.$valid) {
				var allow_submit = false;
				var regexp = /^[a-zA-Z ]*$/;
				var firstname = $scope.user.firstname;
				var lastname = $scope.user.lastname;

				var txt = firstname.toUpperCase();
				if (!regexp.test(txt)) {
					ltxt = lastname.toUpperCase();
					if (!regexp.test(ltxt)) {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							template: 'Firstname and lastname must contain alphabets only',
							cssClass: 'my-custom-popup',
						});
						allow_submit = false;
					} else {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							template: 'Firstname must contain alphabets only',
							cssClass: 'my-custom-popup',
						});
						allow_submit = false;
					}
				} else {
					var txt = lastname.toUpperCase();
					if (!regexp.test(txt)) {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							template: 'Lastname must contain alphabets only',
							cssClass: 'my-custom-popup',
						});
						allow_submit = false;
					} else {
						allow_submit = true;
					}
				}

				if (allow_submit) {

					$ionicLoading.hide();
					generalService.mobileRegistered($scope.user.mobile, $scope.user.email).then(function (result) {
						//mobile already exist or cus reg reaches limit
						if (result.data.msg) {
							console.log(result.data.msg);
							/*toast*/
							$cordovaToast.show(result.data.msg, "long", "center").then(
								function (success) {
									// success
								},
								function (error) {
									// error
								}
							);
							/*end of toast*/
						} else {
							//not registered
							console.log(result.data.msg);
							generalService.otpData = {
								flag: 0,
								type: "reg",
								userdata: $scope.user
							};
							$scope.user = {};
							$window.location.href = "#/app/otp";
						}
					});
				}
				$ionicLoading.hide();
			}
			else {
				//disable loading
				$ionicLoading.hide();
				if (form.firstname.$invalid) {
					$cordovaToast.show("Firstname is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.lastname.$invalid) {
					$cordovaToast.show("Lastname is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.email.$invalid) {
					$cordovaToast.show("Enter valid email!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.mobile.$invalid) {
					$cordovaToast.show("Please enter 10 digit mobile number..", "long", "center")
						.then(
							function (success) {
								// success
							},
							function (error) {
								// error
							}
						);
				} else if (form.passwd.$invalid) {
					$cordovaToast.show("Enter 8-16 character password", "long", "center")
						.then(
							function (success) {
								// success
							},
							function (error) {
								// error
							}
						);
				} else if (form.cpasswd.$invalid) {
					$cordovaToast.show("Re-enter password in confirm password field", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.agree.$invalid) {
					$cordovaToast.show("Please accept the Terms and Conditions", "long", "center")
						.then(
							function (success) {
								//success
							},
							function (error) {
								// error
							}
						);
				} else {
					$cordovaToast.show("Password and confirm password should be same", "long", "center")
						.then(
							function (success) {
								// success
							},
							function (error) {
								// error
							}
						);
				}
				$ionicLoading.hide();
			}
		};

		//$scope.autocomplete ={};
		$scope.ReginputType = 'password';
		// Hide & show password function
		$scope.pwdhideshow = function () {
			if ($scope.ReginputType == 'password') {
				$scope.ReginputType = 'text';
			} else {
				$scope.ReginputType = 'password';
			}
		};

		$scope.cninputType = 'password';
		$scope.cpwdhideshow = function () {
			if ($scope.cninputType == 'password') {
				$scope.cninputType = 'text';
			} else {
				$scope.cninputType = 'password';
			}
		};
	})

	//otp controller
	.controller("OtpCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $localstorage, $ionicPlatform, $ionicLoading, $cordovaToast) {
		$scope.rcvdData = {};
		$scope.user = {};
		$scope.rcvdOTP = {};
		$scope.errormsg = "";
		$scope.schemes = [];
		//	$scope.user = [];
		$scope.existing = [];
		$scope.branch = [];
		$scope.showLogin = true;

		//for watching otp reception
		/* 		$ionicPlatform.ready(function () {
						document.addEventListener("deviceready", function () {
							if (SMS) SMS.startWatch(function () {
								console.log('watching started');
							}, function () {
								console.log('failed to start watching');
							});
	
							if (!SMS) { console.log('SMS plugin not ready - OTP'); return; }
	
							document.addEventListener('onSMSArrive', function (e) {
								var data = e.data;
								var currentotp = "";
								var receivedsms = JSON.stringify(data);
								console.log(receivedsms);
								var senderid = data.address.split('-');
								console.log(generalService.senderid);
								if (senderid[1] == generalService.senderid) {
									var body = data.body;
	
									//splitting otp and date
									// var rcvd = body.split(':');
									var rcvd = body.split("P");
									rcvd = rcvd[1].split("f");
									var rcvdotp = rcvd[0].trim();
									// rcvd = rcvd[1].split("l");
									// rcvd = rcvd[3].split("u");
									// var rcvdDate = rcvd[0];
									//$scope.rcvdOTP = { "otp" : rcvdotp, "expiry" : rcvdDate };
									//$scope.rcvdOTP.otp = rcvdotp;
									// $scope.rcvdOTP.expiry = rcvdDate;
									$scope.user.otp = rcvdotp;
									// document.getElementById("userotp").value=trim(rcvdotp);
									//$scope.apply();
									$scope.verifyOtp(document.getElementById("verification"));
									console.log(rcvdotp);
									// An alert dialog
	
									$ionicPopup.alert({
									  title: 'sms received',
									  template: 'otp : '+ rcvdotp +' date : '+rcvdDate
									});
								}
							});
						}, false);
					}); */

		$scope.resendotp = function () {
			//load spinner
			$ionicLoading.show({
				content: "Loading",
				template: 'Re-Sending OTP <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			var mobile = $scope.rcvdData.userdata.mobile;
			console.log(mobile);

			//generate otp

			generalService.registerOTP(mobile).then(function (result) {
				generalService.otpData.otpDetail = result.data;
				$scope.rcvdData.otpDetail = result.data;
				console.log(result.data);

				//close spinner
				$ionicLoading.hide();
			});
		};

		//verify otp
		$scope.verifyOtp = function (form) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Verifying  <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if (form.$valid) {
				console.log($scope.user.otp);

				//verify otp
				return $http({
					method: "POST",
					url: generalService.baseurl + "index.php/mobile_api/check_regOTP",
					data: {
						sysotp: $scope.rcvdData.otpDetail.otp,
						last_otp_expiry: $scope.rcvdData.otpDetail.expiry,
						userotp: $scope.user.otp
					},
					headers: {
						"Content-Type": "application/x-www-form-urlencoded; charset=UTF-8"
					}
				}).then(function (result) {
					if (result.data.is_valid) {
						var customer = {};
						angular.extend(customer, $scope.rcvdData.userdata);
						console.log(customer);

						//register

						if ($scope.rcvdData.type == "reg") {
							var deviceData = {
								token: generalService.deviceRegData.token,
								uuid: generalService.deviceRegData.uuid,
								device_type: generalService.deviceRegData.device_type
							};

							var postData = angular.merge({}, customer, deviceData);

							//send customer data to server
							generalService.customerRegister(postData).then(function (register) {
								//alert('register'+JSON.stringify(postData));
								$ionicLoading.hide();
								generalService.otpData = "";
								$scope.rcvdData = "";
								generalService.otpData = "";
								console.log(register.data.msg);
								if (register.data.status == true) {
									$localstorage.setObject("logincred", {
										mobile: postData.mobile,
										passwd: postData.passwd,
										rememberme: true
									});

									/* 	if (SMS) SMS.stopWatch(function () {
															console.log('watching stopped');
														}, function () {
															console.log('failed to stop watching');
														}); */

									$window.location.href = "#/app/home";
								} else {
									$ionicLoading.hide();
									$cordovaToast.show(register.data.msg, "long", "top").then(
										function (success) {
											success;
										},
										function (error) {
											error;
										}
									);
								}

								$scope.register.reset();
							});
						} else if ($scope.rcvdData.type == "existing_reg" || $scope.rcvdData.type == "existing_reg_by_mob") {
							var mobile = $scope.user.mobile;
							var acc_name = $scope.user.firstname + " " + $scope.user.lastname;
							var postData = {
								'id_customer': $scope.user.id_customer,
								'mobile': mobile,
								'id_scheme': $scope.existing.id_scheme,
								'group_code': $scope.existing.code,
								'scheme_acc_number': $scope.existing.scheme_acc_number,
								'id_branch': $scope.existing.id_branch,
								'account_name': $scope.existing.account_name === undefined ? acc_name : $scope.existing.account_name,
								'is_new': "N"
							};
							generalService.submit_schregOtp(postData).then(function (result) {
								if (result.data) {
									if (result.data.status == true) {
										$window.location.href = "#/app/myschemes/s";
									} else {
										var confirmDelPopup = $ionicPopup.confirm({
											title: "Error",
											template: result.data.msg
										});
										confirmDelPopup.then(function (res) {
											if (res === true) {
												$window.location.href = "#/app/home";
											}
										});
									}
								}
								$ionicLoading.hide();
							});
						} else {
							$ionicLoading.hide();
							$window.location.href = "#/app/resetpassword";
						}
					} else {
						$ionicLoading.hide();
						$scope.errormsg = result.data.msg;
					}
				});
			} else {
				if ($scope.user.otp != "" && $scope.user.otp != undefined) {
					if ($scope.user.otp.length == 6) {
						return $http({
							method: "POST",
							url: generalService.baseurl + "index.php/mobile_api/check_regOTP",
							data: {
								sysotp: $scope.rcvdData.otpDetail.otp,
								last_otp_expiry: $scope.rcvdData.otpDetail.expiry,
								userotp: $scope.user.otp
							},
							headers: {
								"Content-Type": "application/x-www-form-urlencoded; charset=UTF-8"
							}
						}).then(function (result) {
							console.log(result);
							if (result.data.is_valid) {
								var customer = {};
								angular.extend(customer, $scope.rcvdData.userdata);
								//register
								if ($scope.rcvdData.type == "reg") {
									var deviceData = {
										token: generalService.deviceRegData.token,
										uuid: generalService.deviceRegData.uuid,
										device_type: generalService.deviceRegData.device_type
									};

									var postData = angular.merge({}, customer, deviceData);
									//send customer data to server
									generalService.customerRegister(postData).then(function (register) {
										$ionicLoading.hide();
										generalService.otpData = "";
										$scope.rcvdData = "";
										generalService.otpData = "";
										console.log(register.data.msg);
										if (register.data.status == true) {
											$localstorage.setObject("logincred", {
												mobile: postData.mobile,
												passwd: postData.passwd,
												rememberme: true
											});

											/* if (SMS) SMS.stopWatch(function () {
											console.log('watching stopped');
										  }, function () {
											console.log('failed to stop watching');
										  }); */

											$window.location.href = "#/app/home";
										} else {
											$ionicLoading.hide();
											$cordovaToast
												.show(register.data.msg, "long", "top")
												.then(
													function (success) {
														success;
													},
													function (error) {
														error;
													}
												);
										}

										$scope.register.reset();
									});
								} else if (
									$scope.rcvdData.type == "existing_reg" || $scope.rcvdData.type == "existing_reg_by_mob"
								) {
									console.log(generalService.exisRegData);
									if ($scope.rcvdData.type == "existing_reg") {
										var postData = {
											'id_customer': generalService.userData.profile.id_customer,
											'group_name': generalService.exisRegData.group_name,
											'scheme_acc_number': generalService.exisRegData.scheme_acc_number
										};
									} else {
										//				alert('else 1 :existing_reg_by_mob 1 ');
										var id_customer = $scope.user.id_customer;
										var id_scheme = $scope.existing.id_scheme;
										var mobile = $scope.user.mobile;
										var acc_name =
											$scope.user.firstname + " " + $scope.user.lastname;
										var postData = {
											'id_customer': id_customer,
											'mobile': mobile,
											'id_scheme': $scope.existing.id_scheme,
											'group_code': $scope.existing.code,
											'scheme_acc_number': $scope.existing.scheme_acc_number,
											'id_branch': $scope.existing.id_branch,
											'account_name': $scope.existing.account_name === undefined ? acc_name : $scope.existing.account_name,
											'is_new': "N"
										};
									}
									generalService.submit_schregOtp(postData).then(function (result) {
										if (result.data) {
											if (result.data.status == true) {
												$window.location.href = "#/app/myschemes/s";
											} else {
												var confirmDelPopup = $ionicPopup.confirm({
													title: "Error",
													template: result.data.msg
												});
												confirmDelPopup.then(function (res) {
													if (res === true) {
														$window.location.href = "#/app/home";
													}
												});
											}
										}
										$ionicLoading.hide();
									});
								} else {
									//forgetpasswd
									$ionicLoading.hide();
									$window.location.href = "#/app/resetpassword";
								}
							} else {
								$ionicLoading.hide();
								$scope.errormsg = result.data.msg;
							}
						});
						$ionicLoading.hide();
					}
				}
				$ionicLoading.hide();
			}
			$ionicLoading.hide();
		};

		$scope.$on("$ionicView.enter", function (e) {
			$scope.rcvdData = generalService.otpData;
			console.log($scope.rcvdData);
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			var mobile = $scope.rcvdData.userdata.mobile;
			$scope.msg = "";

			//load spinner
			$ionicLoading.show({
				content: "Loading",
				template: 'Sending OTP<br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if (
				$scope.rcvdData.type == "existing_reg" || $scope.rcvdData.type == "existing_reg_by_mob") {
				$scope.msg = "We sent OTP to mobile number associated with saving scheme account.Enter OTP to verify your account.";
			}
			//generate otp
			generalService.registerOTP(mobile).then(function (result) {
				generalService.otpData.otpDetail = result.data;
				$scope.rcvdData.otpDetail = result.data;
				console.log(result.data);

				//close spinner
				$ionicLoading.hide();
			});
		});
	})

	//reports
	.controller("ReportCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, reportID, $ionicPopup) {
		$scope.payments = [];
		$scope.chitaccounts = [];
		$scope.chitscheme = [];
		$scope.payContent = [];
		$scope.allowDelete = [];
		$scope.isdiplay = false;

		$scope.showsearch = function () {
			$scope.isdiplay = !$scope.isdiplay;
		};

		$scope.PayHistory = function (pay) {
			console.log(pay.payment_type);
			var show_c_blk = pay.payment_type == "Payu Checkout" && pay.add_charges != null && pay.add_charges != 0.0 ? true : false;
			var show_d_blk = pay.discount != null && pay.discount != 0.0 ? true : false;
			var show_g_blk = pay.gst != null && pay.gst != 0.0 ? true : false;
			var gst_text = pay.gst_type == 0 ? "Scheme Payment inclusive of GST" : "";
			var showAlert = $ionicPopup.alert({
				title: "Payment Detail",
				template: '<div class="row padding-vertical"><div class="col-50">Scheme Payment</div><div class="col-33">:  ' + pay.currency_symbol + " " + pay.payment_amount + '</div></div><div class="row padding-vertical" ng-if="' + show_c_blk + '"><div class=" col-50">' + pay.charge_head + '</div><div class="col-33">:  ' + pay.currency_symbol + " " + pay.add_charges + '</div></div><div class="row padding-vertical" ng-if="' + show_d_blk + '"><div class="col-50">Discount</div><div class="col-33">:  ' + pay.currency_symbol + " " + pay.discount + '</div></div><div class="row padding-vertical"  ng-if="' + show_g_blk + '"><div class="col-50">GST</div><div class="col-33">:  ' + pay.currency_symbol + " " + pay.paid_gst + '</div></div><div class="row padding-vertical"  ng-if="' + show_g_blk + '"><div class="col-100" style="color :#F35048">' + gst_text + "</div></div>",
				cssClass: "view-detail-popup"
			});
		};

		// Refresh
		/*  $scope.doRefresh = function() {
					 $scope.chitaccounts ="";
					var url = generalService.baseurl + "index.php/mobile_api/customerSchemes?id_customer=" + generalService.userData.profile.id_customer;
				$http.get(url)
				 .success(function(data) {
							console.log(data);
				   $scope.chitaccounts = data.chits;
				 })
				 .finally(function() {
				   // Stop the ion-refresher from spinning
				   $scope.$broadcast('scroll.refreshComplete');
				 });
			  };*/

		$scope.deleteSch = function (id) {
			var confirmDelPopup = $ionicPopup.confirm({
				title: "Confirm Scheme Delete",
				template: "Are you sure? Do you want to delete scheme account?"
			});
			confirmDelPopup.then(function (res) {
				if (res === true) {
					generalService.deleteScheme(id).then(function (result) {
						if (result.data.status) {
							$scope.chitaccounts = "";
							$ionicLoading.show({
								content: "Loading",
								template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
								showBackdrop: true,
								maxWidth: 200,
								showDelay: 0
							});
							generalService.getCustomerSchemes().then(function (result) {
								if (result.data) {
									$scope.chitaccounts = result.data.chits;
									$scope.allowDelete = result.data.allowDelete;
								} else {
									$scope.errormsg = "You don't have any saving scheme.";
								}
								$ionicLoading.hide();
							});
						} else {
							$scope.errormsg = result.data.msg;
						}
					});
				}
			});
		};
		$scope.$on("$ionicView.enter", function (e) {
			$scope.user = generalService.userdata;
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;

			console.log($scope.currency);
			//get payments
			if (reportID == "s") {
				$ionicLoading.show({
					content: "Loading",
					template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
					showBackdrop: true,
					maxWidth: 200,
					showDelay: 0
				});

				generalService.getCustomerSchemes().then(function (result) {
					//generalService.chits = result.data.chits;
					if (result.data) {
						$scope.chitaccounts = result.data.chits;
						$scope.allowDelete = result.data.allowDelete;
						console.log($scope.chitaccounts);
						if ($scope.chitaccounts.length == 0) {
							$scope.errormsg =
								"You don't have any saving scheme , please click below join button to join new scheme";
						} else {
							$scope.errormsg = "";
						}
					} else {
						$scope.errormsg = "You don't have any saving scheme";
					}
					$ionicLoading.hide();
				});
			} else if (reportID == "p") {
				$ionicLoading.show({
					content: "Loading",
					template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
					showBackdrop: true,
					maxWidth: 200,
					showDelay: 0
				});
				generalService.getPayments().then(function (result) {
					if (result.data) {
						$scope.payments = result.data;
						if ($scope.payments.length == 0) {
							$scope.errormsg = "You have not made any payments";
						} else {
							$scope.errormsg = "";
						}
					} else {
						$scope.errormsg = "You have not made any payments";
					}
					$ionicLoading.hide();
				});
				generalService.getCustomerDashboard().then(function (result) {
					$scope.payContent = result.data;
					$ionicLoading.hide();
				});
			} else {
				$ionicLoading.show({
					content: "Loading",
					template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
					showBackdrop: true,
					maxWidth: 200,
					showDelay: 0
				});
				generalService.getChitSchemeDetail(reportID).then(function (result) {
					if (result.data) {
						$scope.chitscheme = result.data;
					} else {
						$scope.errormsg = "";
					}
					$ionicLoading.hide();
				});
			}
		});
	})

	//Scheme Detail
	.controller("SchemeDetailCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, schemeID, $ionicPopup) {
		$scope.schemedetail = [];
		$scope.allow_joined = [];
		if (generalService.userData.logged != 1) {
			$ionicLoading.hide();
			$window.location.href = "#/app/login";
		} else {
			if (schemeID != "") {
				$ionicLoading.show({
					content: "Loading",
					template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
					showBackdrop: true,
					maxWidth: 200,
					showDelay: 0
				});

				generalService.getScheme(schemeID).then(function (result) {
					if (result.data) {
						$scope.schemedetail = result.data.scheme;
						$scope.allow_joined = result.data.allow_join;
					} else {
						$scope.errormsg = "";
					}
					$ionicLoading.hide();
				});
			} else {
				$ionicLoading.hide();
				$scope.errormsg = "";
			}
		}
	})

	//Payment scheme
	.controller("PaymentCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $sce, $ionicLoading, $ionicModal, $filter, $cordovaToast) {
		$scope.user = [];
		$scope.chitaccounts = [];
		$scope.pay = [];
		$scope.paynow = [];
		$scope.metalrate = [];
		$scope.weights = [];
		$scope.sel_wts = [];
		$scope.weight_view = "";
		$scope.wt_pay = "";
		$scope.gold_rate = "";
		$scope.chitaccount = [];
		$scope.payment_array = [];
		$scope.pay_amt = 0.0;
		$scope.allow_walletpopup = [];

		$scope.proceed_pay = function () {
			var proceedPay = true;
			if ($scope.payment_array.length > 0) {
				angular.forEach($scope.payment_array, function (item, key) {
					if (item.scheme_type == 3) {
						if (item.amount < item.min_amt || item.amount > item.max_amt) {
							proceedPay = false;
						}
					}
				});
				if (proceedPay) {
					console.log($scope.allow_walletpopup);
					if ($scope.allow_walletpopup == 1) {
						var wallet = $scope.walletData;
						$scope.data = [];
						if (wallet) {
							var wal_balance = (parseFloat(wallet.wal_balance));
							var redeem_percent = (parseFloat(wallet.redeem_percent));
							if (wal_balance > 0 && redeem_percent > 0) {
								var can_redeem = 0;
								var allowed_redeem = (generalService.total_pay_amt * (redeem_percent / 100));
								if (allowed_redeem > wal_balance) {
									can_redeem = Math.floor(wal_balance);
								} else {
									can_redeem = Math.floor(allowed_redeem);
								}
								$scope.data.msg = 'Maximum redeem : ' + can_redeem;
								$scope.data.redeemed_amount = can_redeem;
								var myPopup = $ionicPopup.show({
									title: 'Do you want to use wallet points?',
									//subTitle: 'Do you want to use wallet points?',
									scope: $scope,
									template: $scope.data.msg + '<br/>Redeem points : <input type="number" step="1" ng-model="data.redeemed_amount" class="popup-boxctrl" >',
									//	template: 'Allowed Redeem Point ' + '&nbsp;&nbsp;&nbsp;' + redeemed_amount + '<br>' + 'Payment Amount' + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + wallet_tot,
									message: '',
									buttons: [
										{
											text: 'No',
											onTap: function (e) {
												$scope.data.redeemed_amount = 0;
												return $scope.data.redeemed_amount;
											}
										},
										{
											text: '<b>Yes</b>',
											type: 'button-positive',
											onTap: function (e) {
												if (!$scope.data.redeemed_amount) {
													//don't allow the user to close unless he enters value
													e.preventDefault();
												} else if ($scope.data.redeemed_amount > can_redeem) {
													//don't allow the user to close unless he enters value
													e.preventDefault();
												} else {
													$scope.data.msg = '';
													return $scope.data.redeemed_amount;
												}
											}
										}
									]
								});

								myPopup.then(function (res) {
									if (res > 0) {
										var wallet_tot = (generalService.total_pay_amt) - Math.floor($scope.data.redeemed_amount);
										generalService.total_pay_amt = wallet_tot;
										generalService.redeemed_amount = Math.floor($scope.data.redeemed_amount);
										if (generalService.total_pay_amt == 0) {
											var postData = {
												'pay_arr': generalService.payment_array,
												'redeemed_amount': generalService.redeemed_amount,
												'phone': generalService.userData.mobile,
											}
											generalService.redeemPoints(JSON.stringify(postData)).then(function (result) {
												if (result.data) {
													$cordovaToast
														.show(result.data.msg, 'long', 'center')
														.then(function (success) {
															// success
														}, function (error) {
															// error
														});
													if (result.data.ststus) {
														$window.location.href = "#/app/dashboard";
													}
												}
											})
										} else {
											$window.location.href = "#/app/payview";
										}
									} else {
										$window.location.href = "#/app/payview";
									}
								});

							} else {
								$window.location.href = "#/app/payview";
							}
						} else {
							$window.location.href = "#/app/payview";
						}
					} else {
						$window.location.href = "#/app/payview";
					} // end allow_walletpopup
				} else {
					$cordovaToast
						.show("Please enter valid amount", "long", "center")
						.then(
							function (success) {
								// success
							},
							function (error) {
								// error
							}
						);
				}
			} else {
				$cordovaToast
					.show("select scheme(s) to proceed", "long", "center")
					.then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
			}
		};

		$scope.checkAmt = function (pay_data) {
			var accData = $filter("filter")($scope.payment_array, {
				udf1: pay_data.id_scheme_account
			});
			if (accData.length >= 1) {
				angular.forEach(accData, function (item, key) {
					var idx = $scope.payment_array.indexOf(item);
					if (idx > -1) {
						$scope.payment_array.splice(idx, 1);
						var payable = pay_data.payable == null ? 0 : pay_data.payable;
						if (pay_data.allowPayDisc == 1) {
							var calc_discount = pay_data.firstPayDisc_by == 1 ? pay_data.discount : (parseFloat(payable) * (parseFloat(pay_data.discount) / 100)).toFixed(2);
							var amount = (parseFloat(payable) - parseFloat(calc_discount)).toFixed(2);
							var discountedAmt = calc_discount;
						} else {
							var amount = parseFloat(payable);
							var discountedAmt = 0.0;
						}
						var acc_no = pay_data.chit_number != null ? pay_data.chit_number : "Not Allocated";
						/* var amount = parseFloat(payable);*/

						var charge = 0.0;

						if (pay_data.charge_type == 0) {
							var charge = (
								parseFloat(amount) *
								(parseFloat(pay_data.charge) / 100)
							).toFixed(2);
						} else if (pay_data.charge_type == 1) {
							var charge = pay_data.charge;
						}

						//GST Calculation

						var gst_val = 0;
						var gst_amt = 0;

						if (parseFloat(pay_data.gst) > 0) {
							if (pay_data.gst_type == 1) {
								gst_val =
									parseFloat(payable) * (parseFloat(pay_data.gst) / 100);
								gst_amt = gst_val;
							} else {
								gst_val = (
									parseFloat(payable) - parseFloat(payable) * (100 / (100 + parseFloat(pay_data.gst)))
								).toFixed(2);
							}
						}

						var pay_amount = Math.round(
							parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
						);
						$scope.pay = {
							'scheme_type': pay_data.scheme_type,
							'chit_number': pay_data.code + "-" + acc_no,
							'amount': amount,
							'pay_amt': pay_amount,
							'max_amt': pay_data.max_amount,
							'min_amt': pay_data.min_amount,
							'udf1': pay_data.id_scheme_account,
							'udf2': "",
							'udf3': $scope.gold_rate,
							'udf4': amount,
							'udf5': pay_data.sel_due,
							'charge': charge,
							'charge_head': pay_data.charge_head,
							'due_type': pay_data.due_type == "PN" || pay_data.due_type == "AN" ? "ND" : pay_data.due_type,
							'discount': discountedAmt,
							'gst_amt': gst_val
						};

						generalService.currentpayment = $scope.pay;
						//$window.location.href = "#/app/payview";
						$scope.payment_array.push($scope.pay);
						var payment = 0;
						for (var i = 0; i < $scope.payment_array.length; i++) {
							var schac = $scope.payment_array[i];
							payment += parseFloat(schac.pay_amt);
						}
						$scope.pay_amt = Math.round(payment);
						console.log($scope.payment_array);
					}
				});
			}
			$scope.errorrmsg = "Please enter valid amount";
			generalService.payment_array = $scope.payment_array;
			generalService.total_pay_amt = $scope.pay_amt;
		};

		$scope.sub_due = function (pay_data, index) {
			var accData = $filter("filter")($scope.payment_array, {
				udf1: pay_data.id_scheme_account
			});

			if (pay_data.sel_due > 1 && accData.length > 0) {
				pay_data.sel_due--;
				angular.forEach(accData, function (item, key) {
					var idx = $scope.payment_array.indexOf(item);
					$scope.payment_array.splice(idx, 1);
				});
				console.log(accData.length);
				/*for(i=1;i<=pay_data.sel_due ;i++){
						  $scope.add_pay(pay_data,index);
					  }*/
				for (i = 1; i <= pay_data.sel_due; i++) {
					// ND - normal, PN - pending & normal, AN - adv & normal, PD pending due ,AD-adv due
					due_type = "";
					if (pay_data.due_type == "PN") {
						due_type = i == 1 ? "ND" : "PD";
					} else if (pay_data.due_type == "AN") {
						due_type = i == 1 ? "ND" : "AD";
					} else {
						due_type = pay_data.due_type;
					}
					var allow_discount = i == 1 && pay_data.allowPayDisc == 1 ? 1 : 0;
					$scope.add_pay(pay_data, index, due_type, allow_discount);
				}
			}
		};

		$scope.add_due = function (pay_data, index) {
			var accData = $filter("filter")($scope.payment_array, {
				udf1: pay_data.id_scheme_account
			});

			if (pay_data.sel_due < pay_data.max_allowed_limit && accData.length > 0) {
				pay_data.sel_due++;
				angular.forEach(accData, function (item, key) {
					var idx = $scope.payment_array.indexOf(item);
					$scope.payment_array.splice(idx, 1);
				});
				//console.log(accData.length);
				for (i = 1; i <= pay_data.sel_due; i++) {
					// ND - normal, PN - pending & normal, AN - adv & normal, PD pending due ,AD-adv due
					due_type = "";
					if (pay_data.due_type == "PN") {
						due_type = i == 1 ? "ND" : "PD";
					} else if (pay_data.due_type == "AN") {
						due_type = i == 1 ? "ND" : "AD";
					} else {
						due_type = pay_data.due_type;
					}
					var allow_discount = i == 1 && pay_data.allowPayDisc == 1 ? 1 : 0;
					$scope.add_pay(pay_data, index, due_type, allow_discount);
				}
			}
		};
		$scope.add_pay = function (pay_data, index, due_type, allow_discount) {
			var due_no = parseInt(pay_data.paid_installments) + 1;
			pay_data.amt = pay_data.sel_due * pay_data.payable;
			if (
				pay_data.scheme_type == 0 ||
				pay_data.scheme_type == 2 ||
				pay_data.scheme_type == 3
			) {
				// console.log(pay_data);
				if (allow_discount == 1) {
					var calc_discount =
						pay_data.firstPayDisc_by == 1 ?
							pay_data.discount :
							(
								parseFloat(pay_data.payable) *
								(parseFloat(pay_data.discount) / 100)
							).toFixed(2);
					var amount = (
						parseFloat(pay_data.payable) - parseFloat(calc_discount)
					).toFixed(2);
					var discountedAmt = calc_discount;
				} else {
					var amount = parseFloat(pay_data.payable);
					var discountedAmt = 0.0;
				}

				/*  var amount = parseFloat(pay_data.payable);*/
				var charge = 0.0;

				if (pay_data.charge_type == 0) {
					var charge = (
						parseFloat(amount) *
						(parseFloat(pay_data.charge) / 100)
					).toFixed(2);
				} else if (pay_data.charge_type == 1) {
					var charge = pay_data.charge;
				}
				// console.log('charge :'+charge);
				var acc_no =
					pay_data.chit_number != null ? pay_data.chit_number : "Not Allocated";
				//GST Calculation
				var gst_val = 0;
				var gst_amt = 0;
				if (parseFloat(pay_data.gst) > 0) {
					if (pay_data.gst_type == 1) {
						gst_val =
							parseFloat(pay_data.payable) * (parseFloat(pay_data.gst) / 100);
						gst_amt = gst_val;
					} else {
						gst_val = parseFloat(
							parseFloat(pay_data.payable) -
							parseFloat(pay_data.payable) *
							(100 / (100 + parseFloat(pay_data.gst)))
						).toFixed(2);
					}
				}
				console.log(parseFloat(pay_data.gst));
				var pay_amount = Math.round(
					parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
				);
				$scope.pay = {
					'scheme_type': pay_data.scheme_type,
					'chit_number': pay_data.code + "-" + acc_no,
					'amount': amount,
					'pay_amt': pay_amount,
					'max_amt': pay_data.max_amount,
					'min_amt': pay_data.min_amount,
					'udf1': pay_data.id_scheme_account,
					'udf2': "",
					'udf3': $scope.gold_rate,
					'udf4': amount,
					'udf5': pay_data.sel_due,
					'charge': charge,
					'charge_head': pay_data.charge_head,
					'due_type': due_type,
					'discount': discountedAmt,
					'gst_amt': gst_val
				};

				generalService.currentpayment = $scope.pay;
				//$window.location.href = "#/app/payview";
				$scope.payment_array.push($scope.pay);

				/*var total_amt = 0;
						var charge_amt = 0;
						for(var i = 0; i < $scope.payment_array.length; i++){
							var schac = $scope.payment_array[i];
							total_amt += parseFloat(schac.amount);
							charge_amt += parseFloat(schac.charge);
						}
						 $scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
				var payment = 0;
				for (var i = 0; i < $scope.payment_array.length; i++) {
					var schac = $scope.payment_array[i];
					payment += parseFloat(schac.pay_amt);
				}
				$scope.pay_amt = Math.round(payment);
				//  console.log($scope.payment_array);
			} else if (pay_data.scheme_type == 1 && pay_data.is_flexible_wgt == 0) {
				var weight_selected = parseFloat(pay_data.max_weight);
				if (index !== -1) {
					$scope.chitaccounts[index].sel_weight = weight_selected;
				}

				if (pay_data.allowPayDisc == 1) {
					var selected = pay_data.max_weight / 0.5;
					var calc_discount =
						pay_data.firstPayDisc_by == 1 ?
							selected * pay_data.discount :
							(
								parseFloat(pay_data.max_wgt_rate) *
								(parseFloat(pay_data.discount) / 100)
							).toFixed(2);
					var amount = (
						parseFloat(pay_data.max_wgt_rate) - parseFloat(calc_discount)
					).toFixed(2);
					var discountedAmt = calc_discount;
				} else {
					var amount = parseFloat(pay_data.max_wgt_rate);
					var discountedAmt = 0.0;
				}
				/* var amount = parseFloat(pay_data.max_wgt_rate);*/
				var charge = 0.0;

				if (pay_data.charge_type == 0) {
					var charge = (
						parseFloat(amount) *
						(parseFloat(pay_data.charge) / 100)
					).toFixed(2);
				} else if (pay_data.charge_type == 1) {
					var charge = pay_data.charge;
				}
				var acc_no =
					pay_data.chit_number != null ? pay_data.chit_number : "Not Allocated";
				//GST Calculation
				var gst_val = 0;
				var gst_amt = 0;
				if (parseFloat(pay_data.gst) > 0) {
					if (pay_data.gst_type == 1) {
						gst_val =
							parseFloat(pay_data.max_wgt_rate) *
							(parseFloat(pay_data.gst) / 100);
						gst_amt = gst_val;
					} else {
						gst_val = (
							parseFloat(pay_data.max_wgt_rate) -
							parseFloat(pay_data.max_wgt_rate) *
							(100 / (100 + parseFloat(pay_data.gst)))
						).toFixed(2);
					}
				}
				var pay_amount = Math.round(
					parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
				);
				$scope.pay = {
					'scheme_type': pay_data.scheme_type,
					'chit_number': pay_data.code + "-" + acc_no,
					'amount': amount,
					'pay_amt': pay_amount,
					'udf1': pay_data.id_scheme_account,
					'udf2': weight_selected,
					'udf3': $scope.gold_rate,
					'udf4': amount,
					'udf5': pay_data.sel_due,
					'charge': charge,
					'charge_head': pay_data.charge_head,
					'due_type': due_type,
					'discount': discountedAmt,
					'gst_amt': gst_val
				};

				generalService.currentpayment = $scope.pay;
				//$window.location.href = "#/app/payview";
				$scope.payment_array.push($scope.pay);

				//var total_amt = 0;
				//var charge_amt = 0;
				var payment = 0;
				for (var i = 0; i < $scope.payment_array.length; i++) {
					var schac = $scope.payment_array[i];
					//total_amt += parseFloat(schac.amount);
					// charge_amt += parseFloat(schac.charge);
					payment += parseFloat(schac.pay_amt);
				}
				// $scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));
				$scope.pay_amt = Math.round(payment);
				console.log($scope.payment_array);
			}
			generalService.payment_array = $scope.payment_array;
			generalService.total_pay_amt = $scope.pay_amt;
		};

		//pay select  event
		$scope.scheme_payment = function (pay_data, index) {
			pay_data.sel_due = 1;
			pay_data.amt = pay_data.sel_due * pay_data.payable;
			$scope.weight_view = pay_data.scheme_type;
			var accData = $filter("filter")($scope.payment_array, {
				udf1: pay_data.id_scheme_account
			});
			// is currently selected
			if (accData.length >= 1) {
				angular.forEach(accData, function (item, key) {
					var idx = $scope.payment_array.indexOf(item);
					console.log(idx);
					if (idx > -1) {
						$scope.payment_array.splice(idx, 1);
						/* var total_amt = 0;
									 var charge_amt = 0;
										  for(var i = 0; i < $scope.payment_array.length; i++){
											  var schac = $scope.payment_array[i];
											  total_amt += parseFloat(schac.amount);
											  charge_amt += parseFloat(schac.charge);
										  }
									 $scope.pay_amt = Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
						var payment = 0;
						for (var i = 0; i < $scope.payment_array.length; i++) {
							var schac = $scope.payment_array[i];
							payment += parseFloat(schac.pay_amt);
						}
						$scope.pay_amt = Math.round(payment);
					}
				});
			}
			// is newly selected
			else {
				var due_no = parseInt(pay_data.paid_installments) + 1;

				if (pay_data.scheme_type == 0 || pay_data.scheme_type == 2 || pay_data.scheme_type == 3) {
					if (pay_data.allowPayDisc == 1) {
						var calc_discount = pay_data.firstPayDisc_by == 1 ? pay_data.discount : (parseFloat(pay_data.payable) * (parseFloat(pay_data.discount) / 100)).toFixed(2);
						var amount = (parseFloat(pay_data.payable) - parseFloat(calc_discount)).toFixed(2);
						var discountedAmt = calc_discount;
					} else {
						var amount = parseFloat(pay_data.payable);
						var discountedAmt = 0.0;
					}
					var acc_no = pay_data.chit_number != null ? pay_data.chit_number : "Not Allocated";
					/* var amount = parseFloat(pay_data.payable);*/

					var charge = 0.0;

					if (pay_data.charge_type == 0) {
						var charge = (parseFloat(amount) * (parseFloat(pay_data.charge) / 100)).toFixed(2);
					} else if (pay_data.charge_type == 1) {
						var charge = pay_data.charge;
					}

					//GST Calculation

					var gst_val = 0;
					var gst_amt = 0;

					if (parseFloat(pay_data.gst) > 0) {
						if (pay_data.gst_type == 1) {
							gst_val = parseFloat(pay_data.payable) * (parseFloat(pay_data.gst) / 100);
							gst_amt = gst_val;
						} else {
							gst_val = (parseFloat(pay_data.payable) - parseFloat(pay_data.payable) * (100 / (100 + parseFloat(pay_data.gst)))).toFixed(2);
						}
					}

					var pay_amount = Math.round(
						parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
					);

					$scope.pay = {
						'scheme_type': pay_data.scheme_type,
						'chit_number': pay_data.code + "-" + acc_no,
						'amount': amount,
						'pay_amt': pay_amount,
						'max_amt': pay_data.max_amount,
						'min_amt': pay_data.min_amount,
						'udf1': pay_data.id_scheme_account,
						'udf2': "",
						'udf3': $scope.gold_rate,
						'udf4': amount,
						'udf5': pay_data.sel_due,
						'charge': charge,
						'charge_head': pay_data.charge_head,
						'due_type': pay_data.due_type == "PN" || pay_data.due_type == "AN" ?
							"ND" : pay_data.due_type,
						'discount': discountedAmt,
						'gst_amt': gst_val
					};

					generalService.currentpayment = $scope.pay;
					//$window.location.href = "#/app/payview";
					$scope.payment_array.push($scope.pay);

					/*var total_amt = 0;
							  var charge_amt = 0;
							  for(var i = 0; i < $scope.payment_array.length; i++){
								  var schac = $scope.payment_array[i];
								  total_amt += parseFloat(schac.amount);
								  charge_amt += parseFloat(schac.charge);
							  }
							   $scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
					var payment = 0;
					for (var i = 0; i < $scope.payment_array.length; i++) {
						var schac = $scope.payment_array[i];
						payment += parseFloat(schac.pay_amt);
					}
					$scope.pay_amt = Math.round(payment);
					console.log($scope.payment_array);
				} else if (pay_data.scheme_type == 1 && pay_data.is_flexible_wgt == 0) {
					var weight_selected = parseFloat(pay_data.max_weight);
					if (index !== -1) {
						$scope.chitaccounts[index].sel_weight = weight_selected;
					}

					if (pay_data.allowPayDisc == 1) {
						var selected = pay_data.max_weight / 0.5;
						var calc_discount =
							pay_data.firstPayDisc_by == 1 ?
								selected * pay_data.discount :
								(
									parseFloat(pay_data.max_wgt_rate) *
									(parseFloat(pay_data.discount) / 100)
								).toFixed(2);
						var amount = (
							parseFloat(pay_data.max_wgt_rate) - parseFloat(calc_discount)
						).toFixed(2);
						var discountedAmt = calc_discount;
					} else {
						var amount = parseFloat(pay_data.max_wgt_rate);
						var discountedAmt = 0.0;
					}
					/*  var amount = parseFloat(pay_data.max_wgt_rate);*/
					var charge = 0.0;

					if (pay_data.charge_type == 0) {
						var charge = (
							parseFloat(amount) *
							(parseFloat(pay_data.charge) / 100)
						).toFixed(2);
					} else if (pay_data.charge_type == 1) {
						var charge = pay_data.charge;
					}
					var acc_no =
						pay_data.chit_number != null ?
							pay_data.chit_number :
							"Not Allocated";
					//GST Calculation
					var gst_val = 0;
					var gst_amt = 0;
					if (parseFloat(pay_data.gst) > 0) {
						if (pay_data.gst_type == 1) {
							gst_val =
								parseFloat(pay_data.max_wgt_rate) *
								(parseFloat(pay_data.gst) / 100);
							gst_amt = gst_val;
						} else {
							gst_val = (
								parseFloat(pay_data.max_wgt_rate) -
								parseFloat(pay_data.max_wgt_rate) *
								(100 / (100 + parseFloat(pay_data.gst)))
							).toFixed(2);
						}
					}
					var pay_amount = Math.round(
						parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
					);
					$scope.pay = {
						'scheme_type': pay_data.scheme_type,
						'chit_number': pay_data.code + "-" + acc_no,
						'amount': amount,
						'pay_amt': pay_amount,
						'udf1': pay_data.id_scheme_account,
						'udf2': weight_selected,
						'udf3': $scope.gold_rate,
						'udf4': amount,
						'udf5': pay_data.sel_due,
						'charge': charge,
						'charge_head': pay_data.charge_head,
						'due_type': pay_data.due_type == "PN" || pay_data.due_type == "AN" ? "ND" : pay_data.due_type,
						'discount': discountedAmt,
						'gst_amt': gst_val
					};

					generalService.currentpayment = $scope.pay;
					//$window.location.href = "#/app/payview";
					$scope.payment_array.push($scope.pay);

					/*var total_amt = 0;
							  var charge_amt = 0;
							  for(var i = 0; i < $scope.payment_array.length; i++){
								  var schac = $scope.payment_array[i];
								  total_amt += parseFloat(schac.amount);
								  charge_amt += parseFloat(schac.charge);
							  }
							   $scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
					var payment = 0;
					for (var i = 0; i < $scope.payment_array.length; i++) {
						var schac = $scope.payment_array[i];
						payment += parseFloat(schac.pay_amt);
					}
					$scope.pay_amt = Math.round(payment);
					console.log($scope.payment_array);
				} else {
					$scope.weight_view = pay_data.scheme_type;
					if (index !== -1) {
						$scope.chitaccounts[index].sel_weight = parseFloat(
							pay_data.eligible_weight
						);
					}
					if (pay_data.eligible_weight > 0) {
						if (pay_data.allowPayDisc == 1) {
							var selected = pay_data.eligible_weight / 0.5;
							var calc_discount =
								pay_data.firstPayDisc_by == 1 ?
									selected * pay_data.discount :
									(
										parseFloat(pay_data.max_wgt_rate) *
										(parseFloat(pay_data.discount) / 100)
									).toFixed(2);
							var amount = (
								parseFloat(pay_data.max_wgt_rate) - parseFloat(calc_discount)
							).toFixed(2);
							var discountedAmt = calc_discount;
						} else {
							var amount = parseFloat(pay_data.max_wgt_rate);
							var discountedAmt = 0.0;
						}
						console.log(amount);
						var charge = 0.0;

						if (pay_data.charge_type == 0) {
							var charge = (
								parseFloat(amount) *
								(parseFloat(pay_data.charge) / 100)
							).toFixed(2);
						} else if (pay_data.charge_type == 1) {
							var charge = pay_data.charge;
						}
						//GST Calculation
						var gst_val = 0;
						var gst_amt = 0;
						if (parseFloat(pay_data.gst) > 0) {
							if (pay_data.gst_type == 1) {
								gst_val =
									parseFloat(pay_data.max_wgt_rate) *
									(parseFloat(pay_data.gst) / 100);
								gst_amt = gst_val;
							} else {
								gst_val = parseFloat(
									parseFloat(pay_data.max_wgt_rate) -
									parseFloat(pay_data.max_wgt_rate) *
									(100 / (100 + parseFloat(pay_data.gst)))
								).toFixed(2);
							}
						}
						var pay_amount = Math.round(
							parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
						);
						$scope.pay = {
							'scheme_type': pay_data.scheme_type,
							'chit_number': pay_data.chit_number == "" || pay_data.chit_number == null ? pay_data.code + "- Not Allocated" : pay_data.chit_number,
							'amount': amount,
							'pay_amt': pay_amount,
							'charge': charge,
							'charge_head': pay_data.charge_head,
							'udf1': pay_data.id_scheme_account,
							'udf2': pay_data.eligible_weight,
							'udf3': $scope.gold_rate,
							'udf4': amount,
							'udf5': "",
							'discount': discountedAmt,
							'due_type': "ND",
							'gst_amt': gst_val
						};

						generalService.currentpayment = $scope.pay;
						$scope.payment_array.push($scope.pay);

						/*var total_amt = 0;
									var charge_amt = 0;
									for(var i = 0; i < $scope.payment_array.length; i++){
										var schac = $scope.payment_array[i];
										total_amt += parseFloat(schac.amount);
										 charge_amt += parseFloat(schac.charge);
									}
									$scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
						var payment = 0;
						for (var i = 0; i < $scope.payment_array.length; i++) {
							var schac = $scope.payment_array[i];
							payment += parseFloat(schac.pay_amt);
						}
						$scope.pay_amt = Math.round(payment);
						console.log($scope.payment_array);

						//	$window.location.href = "#/app/payview";
					}
				}
			}

			generalService.payment_array = $scope.payment_array;
			generalService.total_pay_amt = $scope.pay_amt;
		};
		$scope.selectWgt = function (chitData, selwgt, index) {
			$scope.selRate = selwgt.rate;
			var accData = $filter("filter")($scope.payment_array, {
				udf1: chitData.id_scheme_account
			});
			var idx = $scope.payment_array.indexOf(accData[0]);
			// if weight changed remove and add in payment_array
			if (selwgt.weight > 0 && idx > -1) {
				$scope.weight_view = chitData.scheme_type;
				if (index !== -1) {
					$scope.chitaccounts[index].sel_weight = parseFloat(selwgt.weight);
				}

				$scope.payment_array.splice(idx, 1);
				/*   var total_amt = 0;
						   var charge_amt = 0;
							for(var i = 0; i < $scope.payment_array.length; i++){
								var schac = $scope.payment_array[i];
								total_amt += schac.amount;
								charge_amt += schac.charge;
							}
							$scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
				var payment = 0;
				for (var i = 0; i < $scope.payment_array.length; i++) {
					var schac = $scope.payment_array[i];
					payment += parseFloat(schac.pay_amt);
				}
				$scope.pay_amt = Math.round(payment);

				if (selwgt.weight <= chitData.eligible_weight) {
					if (chitData.allowPayDisc == 1) {
						var selected = selwgt.weight / 0.5;
						var calc_discount =
							chitData.firstPayDisc_by == 1 ?
								selected * chitData.discount :
								(
									parseFloat(selwgt.rate) *
									(parseFloat(chitData.discount) / 100)
								).toFixed(2);
						var amount = (
							parseFloat(selwgt.rate) - parseFloat(calc_discount)
						).toFixed(2);
						var discountedAmt = calc_discount;
					} else {
						var amount = parseFloat(selwgt.rate);
						var discountedAmt = 0.0;
					}
					var charge = 0.0;

					if (chitData.charge_type == 0) {
						var charge = (
							parseFloat(amount) *
							(parseFloat(chitData.charge) / 100)
						).toFixed(2);
					} else if (chitData.charge_type == 1) {
						var charge = chitData.charge;
					}

					//GST Calculation
					var gst_val = 0;
					var gst_amt = 0;
					if (parseFloat(chitData.gst) > 0) {
						if (chitData.gst_type == 1) {
							gst_val =
								parseFloat(selwgt.rate) * (parseFloat(chitData.gst) / 100);
							gst_amt = gst_val;
						} else {
							gst_val = parseFloat(
								parseFloat(selwgt.rate) -
								selwgt.rate * (100 / (100 + parseFloat(chitData.gst)))
							).toFixed(2);
						}
					}

					var pay_amount = Math.round(
						parseFloat(amount) + parseFloat(charge) + parseFloat(gst_amt)
					);
					$scope.pay = {
						'scheme_type': chitData.scheme_type,
						'chit_number': chitData.chit_number == "" || chitData.chit_number == null ? chitData.code + "- Not Allocated" : chitData.chit_number,
						'amount': amount,
						'pay_amt': pay_amount,
						'charge': charge,
						'charge_head': chitData.charge_head,
						'udf1': chitData.id_scheme_account,
						'udf2': selwgt.weight,
						'udf3': $scope.gold_rate,
						'udf4': amount,
						'udf5': "",
						'discount': discountedAmt,
						'due_type': "ND",
						'gst_amt': gst_val
					};
					generalService.currentpayment = $scope.pay;
					$scope.payment_array.push($scope.pay);

					/*var total_amt = 0;
							  var charge_amt = 0;
							  for(var i = 0; i < $scope.payment_array.length; i++){
								  var schac = $scope.payment_array[i];
								  total_amt += parseFloat(schac.amount);
								  charge_amt += parseFloat(schac.charge);
		  
							  }
							  $scope.pay_amt =  Math.round(parseFloat(total_amt)+parseFloat(charge_amt));*/
					var payment = 0;
					for (var i = 0; i < $scope.payment_array.length; i++) {
						var schac = $scope.payment_array[i];
						payment += parseFloat(schac.pay_amt);
					}
					$scope.pay_amt = Math.round(payment);
				}
			}
			generalService.payment_array = $scope.payment_array;
			generalService.total_pay_amt = $scope.pay_amt;
		};

		$scope.check_minmax = function () {
			var min = 1;
			var max = $scope.max_allowed_limit;
			var value = $scope.allowed_dues;
			if (parseInt(value) < min || isNaN(value) || value.length <= 0)
				$scope.allowed_dues = min;
			else if (parseInt(value) > max) $scope.allowed_dues = max;
			else $scope.allowed_dues = value;
		};

		//change event of allowed dues
		$scope.check_minmax = function () {
			var min = 1;
			var max = $scope.max_allowed_limit;
			var value = $scope.allowed_dues;
			if (parseInt(value) < min || isNaN(value) || value.length <= 0)
				$scope.allowed_dues = min;
			else if (parseInt(value) > max) $scope.allowed_dues = max;
			else $scope.allowed_dues = value;
		};

		//on pay click event of  weight view
		/* $scope.weight_payment = function (wt_data)
			{
				//$ionicLoading.show("Please wait, Loading");
				if(wt_data.total > 0)
				{
	
				if(wt_data.total <= $scope.wt_pay.eligible_weight)
				{
					var charge = 0.00;
					  if($scope.wt_pay.charge_type == 0){
						  var charge = ((parseFloat($scope.wt_pay.total_amt)*(parseFloat($scope.wt_pay.charge)/100)).toFixed(2));
					 }
					 else if($scope.wt_pay.charge_type == 1){
						  var charge = $scope.wt_pay.charge;
	
					 }
					 console.log($scope.wt_pay);
					 var acc_no =  ($scope.wt_pay.account_no != null ?  $scope.wt_pay.account_no : 'Not Allocated');
				$scope.pay = {
											'scheme_type' : $scope.wt_pay.scheme_type,
											'amount'      : $scope.wt_pay.total_amt,
											'firstname'   : $scope.user.firstname,
											'lastname'    : $scope.user.lastname,
											'Zipcode'     : $scope.user.pincode,
											'email'       : $scope.user.email,
											'phone'       : $scope.user.mobile,
											'productinfo' : $scope.wt_pay.code,
											'chit_number' : $scope.wt_pay.code+'-'+acc_no,
											'udf1'        : $scope.wt_pay.id_scheme_account,
											'udf2'        : $scope.wt_pay.total_wt,
											'udf3'        : $scope.gold_rate,
											'udf4'        : '',
											'udf5'        : '',
											'charge'	  : charge,
											'charge_head' : $scope.wt_pay.charge_head,
											'pay_type'	  : '
											'
										}
	
						generalService.currentpayment = $scope.pay;
						console.log(wt_data);
						console.log(generalService.currentpayment);
						$window.location.href = "#/app/payview";
	
	
				}
				else
				{
					$scope.errormsg = "You have selected weight more than eligibility. Please select weight according to your eligible weight";
				}
			 }
			  else
			  {
				  $scope.errormsg = "You have not selected any weight to proceed payment";
			  }
			}*/

		//get the selected value of checkboxes in weight scheme payment
		$scope.selected_weight = function (weight) {
			var idx = $scope.sel_wts.indexOf(weight);

			// is currently selected
			if (idx > -1) {
				$scope.sel_wts.splice(idx, 1);
			}
			// is newly selected
			else {
				$scope.sel_wts.push(weight);
			}
			console.log($scope.sel_wts);
		};

		//calculate total weight and total amount for weight scheme
		$scope.getTotalSelected = function (sel_wts) {
			var total = 0.0;
			var total_amt = 0.0;

			angular.forEach(sel_wts, function (item, key) {
				total = parseFloat(total) + parseFloat(item);
			});

			total_amt =
				parseFloat($scope.metalrate.goldrate_22ct) * parseFloat(total);
			$scope.wt_pay.total_wt = parseFloat(total).toFixed(3);
			$scope.wt_pay.total_amt = parseFloat(Math.round(total_amt)).toFixed(2);

			return {
				total: parseFloat(total).toFixed(3),
				total_amt: parseFloat(Math.round(total_amt)).toFixed(2)
			};
		};

		//disable pay button to restrict payment from user
		$scope.allowPay = function (allow) {
			if (allow == "N") {
				return true;
			} else {
				return false;
			}
		};

		$scope.showModal = function (templateUrl, type, content) {
			$ionicModal
				.fromTemplateUrl(templateUrl, {
					scope: $scope,
					animation: "slide-in-up"
				})
				.then(function (modal) {
					$scope.modal = modal;
					$scope.type = type;
					$scope.content = content;
					$scope.modal.show();
				});
		};

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};

		//on payment dues localName
		$scope.$on("$ionicView.enter", function (scopes, states) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.currency = generalService.currency;
			generalService.redeemed_amount = 0;
			$scope.allow_walletpopup = generalService.currency.useWalletForChit
			$scope.metalrate = generalService.metalrate;
			$scope.paynow = generalService.paynow;
			if (generalService.userData.logged != 1) {
				$ionicLoading.hide();
				$window.location.href = "#/app/login";
			} else {
				$scope.user = generalService.userData.profile;

				generalService.getCustomerSchemes().then(function (result) {
					$scope.chitaccounts = "";
					if (result.data) {
						console.log(result.data.chits);
						generalService.chits = result.data.chits;
						$scope.chitaccounts = result.data.chits;
						$scope.walletData = result.data.wallet_balance;
						if (result.data.chits.length == 0) {
							$scope.errormsg =
								"You don't have active scheme accounts to pay, please click below join button to join new scheme";
						}
					}
					$ionicLoading.hide();
				});

				generalService.getWeights().then(function (result) {
					if (result.data) {
						$scope.metalrate = result.data.rates;
						$scope.weights = result.data.weights;
						$scope.wt_pay = generalService.paydata.wt_pay;
						$scope.gold_rate = parseFloat(
							$scope.metalrate.goldrate_22ct
						).toFixed(2);
						//console.log($scope.wt_pay);
					}
					$ionicLoading.hide();
				});
			}
		});
	})


	//GatewayCtrl
	.controller('GatewayCtrl', function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicLoading, $ionicPlatform, $stateParams, $ionicModal, $cordovaToast) {
		$scope.payurl = [];
		$scope.paycurrentchit = [];
		$scope.payupaydetails = [];
		$scope.savedCards = [];
		$scope.content = [];

		$scope.showModal = function (templateUrl, type, content) {
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: 'slide-in-up'
			}).then(function (modal) {
				$scope.modal = modal;
				$scope.type = type;
				$scope.content = content;
				console.log(content);
				$scope.modal.show();
			});
		}

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove()
		};

		$scope.selectedBank = function (bank) {
			$scope.sel_bank = bank;
			$scope.content.bank = bank;
			$scope.content.pg = 'NB';
			console.log($scope.content.bank);
		}


		$scope.$on('$ionicView.enter', function (e) {

			$scope.currency = generalService.currency;
			$scope.payment_array = generalService.payment_array;
			$scope.pay_amt = generalService.total_pay_amt;
			$scope.errormsg = "";
			$scope.showSaveCard = 0;

			if ($stateParams.nbData) {
				$scope.banks = [];
				console.log($stateParams.nbData);
				$scope.banks = $stateParams.nbData;
			}

			if ($stateParams.showSaveOption) {
				$scope.showSaveCard = $stateParams.showSaveOption;
			}



			//	$scope.metalrate =  generalService.metalrate;

			/*$scope.banks = {"AXIB" : "AXIS Bank", "BOIB" : "Bank of India", "Bank of Maharashtra" : "BOMB", "CBIB" : "Central Bank Of India", "CRPB" : "Corporation Bank", "DCBB" : "Development Credit Bank", "FEDB" : "Federal Bank", "HDFB" : "HDFC Bank", "ICIB" : "ICICI Bank", "IDBB" : "Industrial Development Bank of India", "INDB" : "Indian Bank", "INIB" : "IndusInd Bank", "INOB" : "Indian Overseas Bank", "Jammu and Kashmir Bank" : "JAKB", "KRKB" : "Karnataka Bank", "KRVB" : "Karur Vysya - Retail", "KRVBC" : "Karur Vysya - Corporate", "SBBJB" : "State Bank of Bikaner and Jaipur", "SBHB" : "State Bank of Hyderabad", "SBIB" : "State Bank of India", "SBMB" : "State Bank of Mysore", "SBTB" : "State Bank of Travancore", "SOIB" : "South Indian Bank", "UBIB" : "Union Bank - Retail", "UBIBC" : "Union Bank - Corporate", "UNIB" : "United Bank Of India", "VJYB" : "Vijaya Bank", "YESB" : "Yes Bank", "CUBB" : "CityUnion", "CABB" : "Canara Bank", "SBPB" : "State Bank of Patiala", "DSHB" : "Deutsche bank", "162B" : "Kotak Bank", "DLSB" : "Dhanlaxmi Bank", "INGB" : "ING Vysya Bank", "CSBN" : "Catholic Syrian Bank", "PNBB" : "Punjab Nation Bank - Retail", "CPNB" : "Punjab Nation Bank - Corporate"};*/

			$scope.payupaydetails = [];
			$scope.payurl = generalService.payurl;
			$scope.paycurrentchit = generalService.currentpayment;
			//$scope.pay_amt = parseFloat($scope.paycurrentchit.amount)+parseFloat($scope.paycurrentchit.charge);
		})
		$ionicLoading.hide();

		$scope.submitForm = function (form) {

			$scope.payment_array = JSON.stringify(generalService.payment_array);
			$scope.pay_amt = generalService.total_pay_amt;
			console.log(form);
			console.log($scope.content);
			var checkValid = (form != undefined ? (form.$valid ? true : false) : ($scope.content.pg == "NB" ? true : false));
			if (checkValid) {
				$scope.userdata = generalService.userData.profile;
				$scope.redeemed_amount = generalService.redeemed_amount;

				$ionicLoading.show();

				var bankcode = $scope.content.pg == "NB" ? $scope.content.bank : "CC";
				$scope.content.pg = $scope.content.pg == "NB" ? "NB" : "CC";


				var store_card = $scope.content.savecard == true ? 1 : "";


				$submiturl = generalService.baseurl + "index.php/paymt/mobile_payment?firstname=" + $scope.userdata.firstname + "&lastname=" + $scope.userdata.lastname + "&phone=" + $scope.userdata.mobile + "&amount=" + $scope.pay_amt + "&redeemed_amount=" + $scope.redeemed_amount + "&productinfo=" + $scope.paycurrentchit.productinfo + "&email=" + $scope.userdata.email + "&pg=" + $scope.content.pg + "&bankcode=" + bankcode + "&ccnum=" + $scope.content.ccnum + "&ccname=" + $scope.content.ccname + "&ccvv=" + $scope.content.ccvv + "&ccexpmon=" + $scope.content.ccexpmon + "&ccexpyr=" + $scope.content.ccexpyr + "&store_card=" + store_card + "&gateway=" + $stateParams.gateway + "&pay_arr=" + encodeURIComponent($scope.payment_array);

				paymentWindow = $window.open($submiturl, '_blank', 'location=no, clearsessioncache=yes');

				paymentWindow.addEventListener('loadstart', inAppBrowserbLoadStart);
				paymentWindow.addEventListener('loadstop', inAppBrowserbLoadStop);
				paymentWindow.addEventListener('loaderror', inAppBrowserbLoadError);
				paymentWindow.addEventListener('exit', inAppBrowserbClose);
				//$window.location.href = "#/app/payview"

				function inAppBrowserbLoadStart(event) {
					//navigator.notification.activityStart("Please Wait", "Its loading....");
					// alert(event.type + ' -1 ' + event.url);
					$ionicLoading.show();

					if (event.url == generalService.baseurl + "index.php/paymt/failureMURL") {
						paymentWindow.close();
						$ionicLoading.hide();
						$ionicPopup.alert({
							title: 'Sorry',
							template: 'Your transaction has been failed, Please try again'
						});
						$window.location.href = "#/app/home";
					}

					if (event.url == generalService.baseurl + "index.php/paymt/cancelMURL") {
						paymentWindow.close();
						$ionicLoading.hide();
						//	 $scope.closeModal();
						$ionicPopup.alert({
							title: 'Sorry',
							template: 'Your transaction has been cancelled , Please try again'
						});
						$window.location.href = "#/app/home";
					}

				}

				function inAppBrowserbLoadStop(event) {
					//navigator.notification.activityStop();
					// alert(event.type + ' -2 ' + event.url);
					$ionicLoading.hide();
					if (event.url == generalService.baseurl + "index.php/paymt/successMURL") {
						//	alert('success : ');
						paymentWindow.close();
						// $scope.closeModal();
						$ionicPopup.alert({
							title: 'Success',
							template: 'Thanks for your payment with us.Your payment (sub. to realisation) is processed successfully.'
						});
						$window.location.href = "#/app/home";
					}
				}

				function inAppBrowserbLoadError(event) {
					//navigator.notification.activityStop();
					// alert(event.type + ' -3 ' + event.message);
					paymentWindow.close();
					$ionicPopup.alert({
						//title: 'Sorry',
						template: 'Payment Under Process'
					});
					$window.location.href = "#/app/home";
				}

				function inAppBrowserbClose(event) {
					//navigator.notification.activityStop();
					// alert('-4'+event.type);
					paymentWindow.removeEventListener('loadstart', iabLoadStart);
					paymentWindow.removeEventListener('loadstop', iabLoadStop);
					paymentWindow.removeEventListener('loaderror', iabLoadError);
					paymentWindow.removeEventListener('exit', iabClose);
					$ionicLoading.hide();
				}

			}
			else {
				console.log(1);
				//valid check
				// if(checkValid.$invalid){
				// 	alert('ccform invalid');
				// 		  $cordovaToast
				// 		  .show('Please enter valid data', 'long', 'center')
				// 		  .then(function(success) {
				// 			  //success
				// 		  }, function (error) {
				// 			// error
				// 		  });
				// 		}
				// $scope.errormsg = "Please enter valid data";
			}
			if (form.$invalid) {
				//alert('invalid form...');
				$cordovaToast
					.show('Please enter valid data', 'long', 'center')
					.then(function (success) {
						//success
					}, function (error) {
						// error
					});
			}
		}

	})


	.controller("SchemeCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicModal, $ionicLoading, $stateParams, $cordovaToast, $ionicHistory) {
		$scope.schemes = [];
		$scope.user = [];
		$scope.existing = [];
		$scope.branch = [];
		$scope.lookup = [];
		$scope.regExistingReqOtp = 0;
		$scope.input_error = '';
		$scope.chit_branches = [];
		$scope.existing.pan_no = null;
		$scope.panRequired = false;



		$ionicModal.fromTemplateUrl("templates/branch.html", {
			scope: $scope
		})
			.then(function (modal) {
				$scope.autocomplete = modal;
			});

		$scope.open_autocomplete = function (type, object) {
			console.log(type);
			//  console.log(object);
			$scope.lookup.searchText = "";
			$scope.items = "";
			$scope.items = object;
			$scope.type = type;
			$scope.autocomplete.show();
		};

		$scope.closeAutocomplete = function () {
			$scope.autocomplete.hide();
		};

		$scope.closeAutocomplete = function () {
			$scope.autocomplete.hide();
		};

		$scope.clearSearch = function () {
			$scope.lookup.searchText = null;
		};
		$scope.postId = function (type, id, name) {
			if (type == "scheme") {
				var schemeData = [];
				$scope.existing.id_scheme = id;
				$scope.existing.code = name;
				angular.forEach($scope.schemes, function (value, key) {
					if (value['id_scheme'] == id) {
						schemeData = value;
					}
				});

				$scope.panRequired = (schemeData.is_pan_required == "1" ? true : false);
				// alert(JSON.stringify($scope.panRequired));
				$scope.autocomplete.hide();
				$scope.lookup.searchText = "";

				generalService.get_groups(id).then(function (result) {
					console.log(result);
					$ionicLoading.hide();
					$scope.group_codes = result.data;
					console.log(result.data);
				})
			}
			else if (type == "groupcode") {    			// group code working   	
				$scope.existing.id_scheme_group = id;
				$scope.existing.group_code = name;
				$scope.autocomplete.hide();
				$scope.lookup.searchText = "";
			}
			else {
				$scope.existing.id_branch = id;
				$scope.existing.branch = name;
				$scope.existing.pan_no = null;
				$scope.autocomplete.hide();
				$scope.lookup.searchText = "";
			}
		};

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};

		/**** /schemelist autocomplete   ****/
		$scope.zoomImage = function () {
			$scope.showModal("templates/imageZoomView.html");
		};

		$scope.showModal = function (templateUrl) {
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: "slide-in-up"
			})
				.then(function (modal) {
					$scope.modal = modal;
					$scope.type = 1;
					$scope.modal.show();
				});
		};
		$scope.selected = function () { };

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};

		//direct join  regExistingReqOtp
		$scope.joinExisting = function (form) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Just a moment <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});


			if (form.$valid) {

				// Validate PAN
				var regexp = /^[A-Z]{5}\d{4}[A-Z]{1}$/;
				var panno = ($scope.existing.pan_no === undefined ? null : $scope.existing.pan_no);
				$validPan = ($scope.panRequired == false ? true : regexp.test(panno.toUpperCase()));
				if ($validPan) {
					$scope.input_error = '';
				} else {
					$scope.input_error = " Enter valid PAN No. ";
				}

				// Validate ac name	
				var nameRegexp = /^[a-zA-Z ]*$/;
				var acname = $scope.existing.account_name;
				var txt = acname.toUpperCase();
				if (!nameRegexp.test(txt)) {
					$validAc = false;
					$scope.input_error = $scope.input_error + " Account name must contain alphabets only. ";
				} else {
					$validAc = true;
				}

				if ($validAc && $validPan) {

					$ionicLoading.hide();
					var confirmPopup = $ionicPopup.confirm({
						title: "Confirm Scheme Join",
						template: "Are you sure that you have entered correct Ac No and Name?",

						buttons: [
							{
								text: 'No',
								onTap: function (e) {
									return false;
								}
							},
							{
								text: '<b>Yes</b>',
								type: 'button-positive',
								onTap: function (e) {

									return true;
								}
							}
						]
					});
					confirmPopup.then(function (res) {
						if (res === true) {
							var id_customer = $scope.user.id_customer;
							var id_scheme = $scope.existing.id_scheme;
							var mobile = $scope.user.mobile;

							/* 		$ionicLoading.show({
								  content: 'Loading',
								  template: 'Verifying your details <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
								  showBackdrop: true,
								  maxWidth: 200,
								  showDelay: 0
								}); */

							// $cordovaToast.show("Kindly wait for your scheme activation, once activated you will be notified", "8000", "center");
							// $cordovaToast.show('Coming Soon', 'long', 'center');
							// posted fields
							var accData = {
								'id_scheme_group': $scope.existing.id_scheme_group,
								'id_customer': id_customer,
								'mobile': mobile,
								'id_scheme': $scope.existing.id_scheme,
								'regExistingReqOtp': $scope.regExistingReqOtp,
								'group_code': $scope.existing.code,
								'scheme_acc_number': $scope.existing.scheme_acc_number,
								'id_branch': $scope.existing.id_branch,
								'account_name': $scope.existing.account_name === undefined ? acc_name : $scope.existing.account_name,
								'pan_no': ($scope.panRequired == false ? null : panno),
								'is_new': "N"
							};
							generalService.exisRegData = "";
							generalService.exisRegData = accData;
							generalService.joinScheme(accData).then(function (result) {
								console.log(result.data);
								if (result.data) {
									if (result.data.status == true) {
										$ionicLoading.hide();
										if ($scope.regExistingReqOtp == 0) {
											//		$cordovaToast.show('Kindly wait for your scheme activation, once activated you will be notified', '2000', 'center');

											$cordovaToast.show(result.data.msg, 'long', 'center')
												.then(function (success) {
													// success
												}, function (error) {
													// error
												});

											generalService.paynow = result.data.chit;
											generalService.disc = result.data.disc;
											$window.location.href = "#/app/scheme_reg_req";
										} else {
											var otpDetail = result.data.otpDetail;
											generalService.otpData = "";
											generalService.otpData = {
												otpDetail: otpDetail,
												type: "existing_reg",
												userdata: $scope.user
											};
											$window.location.href = "#/app/regotp";
										}
									} else {
										$ionicLoading.hide();
										$scope.errormsg = result.data.msg;
									}
								} else {
									$ionicLoading.hide();
								}
							});
						} else {
							$ionicLoading.hide();
							$scope.errormsg = "";
						}
					});
				}
				$ionicLoading.hide();
			}
			else {
				$ionicLoading.hide();
				if (form.code.$invalid) {
					$cordovaToast.show("Scheme Code is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						});

				}
				else if (form.scheme_acc_number.$invalid) {
					$cordovaToast.show("Account No is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						});

				}
				else if (form.pan_no.$invalid) {
					$cordovaToast.show("Pan No is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						});

				}
				else if (form.account_name.$invalid) {
					$cordovaToast.show("Account Name is required!", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						});
				} else {
					$ionicLoading.hide();
				}

			}
			$ionicLoading.hide();
		};
		//on load schemes view
		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
			});

			generalService.getSchemes().then(function (result) {
				if (result.data) {
					$scope.schemes = result.data.schemes;
					$scope.branch_settings = result.data.chit_settings.branch_settings;
					// alert(JSON.stringify($scope.chit_branches));
					$scope.regExistingReqOtp = result.data.chit_settings.regExistingReqOtp;
					console.log(result.data);
				}
			});

			generalService.get_branch().then(function (result) {
				if (result.data) {
					$scope.branches = result.data;
					//console.log(result.data);
				}
			});


			$ionicHistory.nextViewOptions({
				disableBack: true
			});
			console.log($stateParams);
			if ($stateParams.type == 2) {
				$scope.existing.code = $stateParams.code;
				$scope.existing.id_scheme = $stateParams.id_scheme;
				$scope.panRequired = $stateParams.is_pan_required;
				console.log($scope.existing.is_pan_required);
			}
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			$scope.user = generalService.userData.profile;
			$scope.regExistingScheme = generalService.currency.reg_existing;
			if (generalService.userData.logged != 1) {
				$ionicLoading.hide();
				$window.location.href = "#/app/login";
			}
		});
	})


	//otp controller
	.controller("ExistingRegOtpCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $localstorage, $ionicPlatform, $ionicLoading, $cordovaToast, $ionicHistory) {
		$scope.rcvdData = {};
		$scope.user = {};
		$scope.rcvdOTP = {};
		$scope.errormsg = "";
		$scope.schemes = [];
		$scope.existing = [];
		$scope.branch = [];
		$scope.showLogin = false;

		$scope.resendotp = function () {
			//load spinner
			$ionicLoading.show({
				content: "Loading",
				template: 'Re-Sending OTP <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			var mobile = $scope.rcvdData.userdata.mobile;

			generalService.registerOTP(mobile).then(function (result) {
				generalService.otpData.otpDetail = result.data;
				$scope.rcvdData.otpDetail = result.data;
				console.log(result.data);

				//close spinner
				$ionicLoading.hide();
			});
		};

		//verify otp
		$scope.verifyOtp = function (form) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Verifying  <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			if (form.$valid) {
				var userOTP = $scope.user.otp;
				var customer = {};
				var otpData = {
					sysotp: $scope.rcvdData.otpDetail.otp,
					last_otp_expiry: $scope.rcvdData.otpDetail.expiry,
					userotp: userOTP
				};

				var acc_name = $scope.user.firstname + " " + $scope.user.lastname;
				var postData = {
					'id_customer': $scope.existing.id_customer,
					'mobile': $scope.rcvdData.userdata.mobile,
					'id_scheme': $scope.existing.id_scheme,
					'regExistingReqOtp': $scope.existing.regExistingReqOtp,
					'group_code': $scope.existing.group_code,
					'scheme_acc_number': $scope.existing.scheme_acc_number,
					'id_branch': $scope.existing.id_branch === undefined ? null : $scope.existing.id_branch,
					'account_name': $scope.existing.account_name === undefined ? acc_name : $scope.existing.account_name,
					'is_new': "N"
				};
				console.log($scope.existing);
				angular.extend(postData, otpData);
				console.log(postData);
				generalService.submit_schregOtp(postData).then(function (result) {
					if (result.data) {
						if (result.data.status == true) {
							$window.location.href = "#/app/myschemes/s";
						} else {
							var confirmDelPopup = $ionicPopup.confirm({
								title: "Error",
								template: result.data.msg
							});
							confirmDelPopup.then(function (res) {
								if (res === true) {
									$window.location.href = "#/app/home";
								}
							});
						}
					}
					$ionicLoading.hide();
				});
			}

			$ionicLoading.hide();
		};

		$scope.$on("$ionicView.enter", function (e) {
			$ionicHistory.nextViewOptions({
				disableBack: true
			});
			$scope.rcvdData = generalService.otpData;
			console.log($scope.rcvdData);
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			$scope.existing = generalService.exisRegData;
			$scope.msg = "";

			if (
				$scope.rcvdData.type == "existing_reg" || $scope.rcvdData.type == "existing_reg_by_mob") {
				$scope.msg = "We sent OTP to mobile number associated with saving scheme account.Enter OTP to verify your account.";
			}
		});
	})

	/*  .controller("schemesListCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicModal, $ionicLoading, $stateParams) {
	   $scope.$on("$ionicView.enter", function (e) {
		 $ionicLoading.show({
		   content: "Loading",
		   template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
		 });
		 $scope.classifyData = $stateParams.schemes;
		 $scope.classification = $scope.classifyData.id_classification;
		 console.log($scope.classification);
		 generalService.getActiveSchemes().then(function (result) {
		   //console.log("response"+JSON.stringify(result) );
		   $ionicLoading.hide();
		   $scope.schemes = result.data;
		 });
	   });
	 }) */

	.controller("schemesListCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicModal, $ionicLoading, $stateParams) {
		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
			});
			$scope.id_classification = $stateParams.id_classification;
			$scope.classification_name = $stateParams.cls_name;
			// $scope.classify_name = $scope.classifyData.classification_name; 
			console.log($scope.id_classification);
			console.log($scope.classification);
			console.log($scope.classify_name);
			generalService.getActiveSchemes().then(function (result) {
				$ionicLoading.hide();
				$scope.schemes = result.data;
			});
			generalService.getVisClassification().then(function (result) {
				//alert(''+JSON.stringify(result));
				$scope.classify = result.data;
				$ionicLoading.hide();
			});
		});
	})


	.controller("SavingSchemeCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicModal, $ionicLoading, $stateParams, $ionicSlideBoxDelegate, $ImageCacheFactory) {
		/*     $scope.showSchemes = function (sch) {
				console.log('schemes : '+JSON.stringify(sch));
			  $state.go("app.savingscheme", {schemes: sch});
			  
			}; */

		//on load schemes view
		$scope.$on("$ionicView.enter", function (e) {
			$scope.offers = [];

			$scope.companyName = generalService.companyName;
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			$scope.user = generalService.userData.profile;
			$scope.regExistingScheme = generalService.currency.reg_existing;

			generalService.getVisClassification().then(function (result) {
				//alert(''+JSON.stringify(result));
				$scope.sch_classify = result.data;
				$ionicLoading.hide();
			});

			generalService.getActiveSchemes().then(function (result) {
				$scope.schemes = result.data;
			});

			generalService.getoffers().then(function (result) {
				if (result.data) {
					$scope.offers_banners = result.data.offers_banners;
					$scope.offers = result.data.offers;
					generalService.offers = result.data.offers;
					$ionicSlideBoxDelegate.update();
					$ionicSlideBoxDelegate.$getByHandle("image-viewer").update();

					//Build the list of images to preload
					var sliderimages = [];
					for (var i = 0; i < result.data.offers_banners.length; i++) {
						sliderimages.push(result.data.offers_banners[i].offer_img_path);
					}
					$ImageCacheFactory.Cache(sliderimages);
					//console.log(offerimages);
				}
			});
		});
	})

	//Terms join scheme
	.controller("TermsCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading) {
		$ionicLoading.show({
			content: "Loading",
			template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
		});
		$scope.companyName = generalService.companyName;
		generalService.getClassification().then(function (result) {
			$scope.classify = result.data;
			$ionicLoading.hide();
		});
	})

	.controller("ExistingRegReqCtrl", function ($scope, generalService, $http, $window, $ionicLoading) {
		$scope.$on("$ionicView.enter", function (e) {
			$scope.user = generalService.userdata;
			$ionicLoading.show({
				content: "Loading",
				animation: "fade-in",
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			generalService.getExisRegReq().then(function (result) {
				if (result.data) {
					$scope.chitaccounts = result.data;
					if (result.data.length == 0) {
						$scope.errormsg = "No pending requests found";
					}
				} else {
					$scope.errormsg = "No pending requests found";
				}
				$ionicLoading.hide();
			});
		});
	})
	//join scheme
	.controller("JoinCtrl", function ($scope, generalService, $http, $window, $state, schemeID, $ionicPopup, $ionicLoading, $cordovaToast, $timeout, $ionicModal, $ionicHistory) {
		$scope.scheme = [];
		$scope.joinNew = [];
		$scope.showdesc = false;
		$scope.tot_payable = "";
		$scope.join = [];
		$scope.branch = [];
		$scope.lookup = [];
		$scope.formRef_code = "";
		$scope.input_error = '';
		$scope.panRequired = false;
		$scope.joinNew.pan_no = null;
		$scope.show_referral = '';

		/**** schemelist autocomplete   ****/
		generalService.get_branch().then(function (result) {
			if (result.data) {
				$scope.branches = result.data;
				console.log(result.data);
			}
		});

		$ionicModal.fromTemplateUrl("templates/branch.html", {
			scope: $scope
		}).then(function (modal) {
			$scope.autocomplete = modal;
		});

		$scope.open_autocomplete = function (type, object) {
			$scope.lookup.searchText = "";
			$scope.items = "";
			$scope.items = object;
			$scope.type = type;
			$scope.autocomplete.show();
		};

		$scope.closeAutocomplete = function () {
			$scope.autocomplete.hide();
		};

		$scope.clearSearch = function () {
			$scope.lookup.searchText = null;
		};
		$scope.postId = function (type, id, name) {
			if (type == "branch") {
				$scope.joinNew.id_branch = id;
				$scope.joinNew.branch = name;
				$scope.autocomplete.hide();
				$scope.lookup.searchText = "";
			}
		};

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};

		$scope.toggledescription = function () {
			$scope.showdesc = !$scope.showdesc;
		};

		//join new scheme
		$scope.join_new = function (form) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner>',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			if ($scope.join.agree && form.$valid) {
				// validate pan no
				var regexp = /^[A-Z]{5}\d{4}[A-Z]{1}$/;
				var panno = ($scope.joinNew.pan_no === undefined ? null : $scope.joinNew.pan_no);
				$validPan = ($scope.panRequired == false ? true : regexp.test(panno.toUpperCase()));
				if ($validPan) {
					$scope.input_error = '';
				} else {
					$scope.input_error = " Enter valid PAN No. ";
				}


				// Validate ac name	
				var nameRegexp = /^[a-zA-Z ]*$/;
				var acname = $scope.scheme.account_name;
				var txt = acname.toUpperCase();
				if (!nameRegexp.test(txt)) {
					$validAc = false;
					$scope.input_error = $scope.input_error + " Account name must contain alphabets only. ";
				} else {
					$validAc = true;
				}
				if ($validAc && $validPan) {
					$ionicLoading.hide();
					var confirmPopup = $ionicPopup.confirm({
						title: "Confirm Scheme Join",
						template: "Are you sure?Do you want to join <br/>" + $scope.scheme.scheme_name
					});
					confirmPopup.then(function (res) {
						$ionicLoading.show({
							content: "Loading",
							template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
							showBackdrop: true,
							maxWidth: 200,
							showDelay: 0
						});
						if (res === true) {
							$scope.allowjoin = false;
							var id_customer = $scope.user.id_customer;
							var id_scheme = $scope.scheme.id_scheme;
							var acc_name = $scope.user.firstname + " " + $scope.user.lastname;
							var accData = {
								'id_customer': id_customer,
								'id_scheme': $scope.scheme.id_scheme,
								'group_code': $scope.scheme.code,
								'scheme_acc_number': "",
								'account_name': $scope.scheme.account_name != "" && $scope.scheme.account_name != "undefined" ? $scope.scheme.account_name : acc_name,
								'referal_code': $scope.joinNew.referal_code,
								/* 'referal_code': $scope.scheme.referal_code == "" || $scope.scheme.referal_code == null ? formRef_code : $scope.scheme.referal_code, */
								'pan_no': ($scope.panRequired == false ? null : panno),
								'id_branch': $scope.joinNew.id_branch,
								'is_new': "Y"
							};
							console.log(accData);
							if ((id_scheme != "") & (id_customer != "")) {
								generalService.joinScheme(accData).then(function (result) {
									$scope.allowjoin = true;
									if (result.data.status === true) {
										generalService.paynow = result.data.chit;
										if (result.data.free_pay == "") {
											$window.location.href = "#/app/paydues";
										} else {
											$cordovaToast
												.show(result.data.free_pay, 8000, "center")
												.then(function (success) {
													$ionicHistory.nextViewOptions({
														disableBack: true
													});
													if (result.data.redirectToPay == 1) {
														$window.location.href = "#/app/paydues";
													} else {
														$window.location.href = "#/app/myschemes/s";
													}

												},
													function (error) {
														// error
													}
												);
										}
									} else {
										$cordovaToast.show(result.data.msg, "long", "center").then(
											function (success) {
												$scope.errormsg = result.data.msg;
												//    alert(JSON.stringify($scope.errormsg));
											},
											function (error) {
												// error
											}
										);
									}
									$ionicLoading.hide();
								});
							}
						} else {
							$ionicLoading.hide();
							$scope.errormsg = "";
						}
					});
				}
				$ionicLoading.hide();
			} else {

				//validate accountname & terms & conditions
				if (form.account_name.$invalid) {
					$cordovaToast.show("Please fill account name", "long", "center").then(
						function (success) {
							//success
						},
						function (error) {
							// error
						});
				}

				else if (form.agree.$invalid) {
					$cordovaToast.show("Please accept the Terms and Conditions", "long", "center").then(
						function (success) {
							//success
						},
						function (error) {
							// error
						});

				}
				else if (form.pan_no != undefined) {
					if (form.pan_no.$invalid) {
						$cordovaToast.show("Please Enter Pan no", "long", "center").then(
							function (success) {
								//success
							},
							function (error) {
								// error
							});
					}
				}
				else {
					$ionicLoading.hide();
				}

			}

			$ionicLoading.hide();
		}

		$scope.$on("$ionicView.enter", function (e) {

		

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			$scope.currency = generalService.currency;
			$scope.showcomingsoon = generalService.dashboardData.showcomingsoon;

			console.log(generalService.userData);
			if (generalService.userData.logged != 1) {
				$ionicLoading.hide();
				$window.location.href = "#/app/login";
			} else {
				$scope.user = generalService.userData.profile;
				if (schemeID && schemeID !== undefined) {
					$ionicLoading.show({
						content: "Loading",
						template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
						showBackdrop: true,
						maxWidth: 200,
						showDelay: 0
					});
					generalService.getScheme(schemeID).then(function (result) {
						if (result.data) {
							console.log("scheme id : " + schemeID);
							if (result.data.scheme) {
								$scope.scheme = result.data.scheme;
								$scope.show_referral = result.data.show_referral;    // only allowed single (cus & emp)
								$scope.panRequired = (result.data.scheme.is_pan_required == "1" ? true : false);

								//$scope.weights = result.data.weights;
								$scope.weights = [];
								angular.forEach(result.data.weights, function (item, key) {
									$scope.weights.push({ weight: parseFloat(item.weight) });
								});
								console.log($scope.weights);
								$scope.tot_payable = parseFloat(result.data.scheme.total_installments * result.data.scheme.amount).toFixed(2);
								if (result.data.allow_join.status == false) {
									$scope.errormsg = result.data.allow_join.msg;
									$scope.allowjoin = false;
								} else {
									$scope.allowjoin = true;
								}
								$ionicLoading.hide();
							} else {
								$scope.errormsg = "Saving Scheme is currently unavailable ,Please contact customer care";
								$scope.hide = true;
								$ionicLoading.hide();
							}
						}
					});
				}
			}
		});
	})

	.controller("WalletCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $localstorage, $ionicPlatform, $ionicLoading) {
		$scope.wallets = [];
		$scope.transactions = [];
		$scope.$on("$ionicView.enter", function (e) {
			$scope.currency = generalService.currency;
			$scope.metalrate = generalService.metalrate;
			if (generalService.userData.logged != 1) {
				$window.location.href = "#.app/login";
			} else {
				generalService.getCustomerWallets().then(function (result) {
					if (result.data) {
						$scope.wallets = result.data.wallets;
						$scope.transactions = result.data.transactions;
						if ($scope.wallets.length == 0) {
							$scope.errormsg =
								"Wallet account is not yet activated.Contact customer care.";
						} else {
							$scope.errormsg = "";
						}
					}
				});
			}
		});
	})
	.controller("ProfileCtrl", function ($scope, generalService, $http, $window, $state, $ionicModal, $ionicPopup, $ionicLoading, $localstorage, $ionicPlatform, $cordovaDatePicker, $filter, $cordovaToast) {
		$scope.registration = [];
		$scope.countries = [];
		$scope.states = [];
		$scope.cities = [];
		$scope.user = [];
		$scope.lookup = [];
		//$scope.autocomplete ={};

		//date-picker
		$scope.getDate = function () {
			console.log($scope.registration.date_of_birth);
			var options = {
				date: new Date(),
				mode: "date", // or 'time'
				minDate: new Date() - 10000,
				allowOldDates: true,
				allowFutureDates: false,
				doneButtonLabel: "DONE",
				doneButtonColor: "#F2F3F4",
				cancelButtonLabel: "CANCEL",
				cancelButtonColor: "#000000"
			};

			document.addEventListener("deviceready", function () {
				$cordovaDatePicker.show(options).then(function (date) {
					console.log(date);
				});
			},
				false
			);
		};

		//modal
		$ionicModal.fromTemplateUrl("templates/autocomplete.html", {
			scope: $scope
		}).then(function (modal) {
			$scope.autocomplete = modal;
		});

		//loading
		$ionicLoading.show({
			content: "Loading",
			template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
			showBackdrop: true,
			maxWidth: 200,
			showDelay: 0
		});
		$scope.getState = function (id_country) {
			generalService.getState(id_country).then(function (result) {
				$scope.states = result.data;
				$ionicLoading.hide();
			});
		};

		/*** Autocomplete***/
		$scope.open_autocomplete = function (type) {
			$scope.lookup.searchText = "";
			$scope.items = "";
			//$scope.items =object;
			$scope.selectType = type;

			$scope.autocomplete.show();
		};
		$scope.getLookupText = function (e, query) {
			if (query.length >= 3) {
				if ($scope.selectType) {
					switch ($scope.selectType) {
						case "city":
							if ($scope.registration.id_state) {
								generalService.getMatchingCity(query, $scope.registration.id_state)
									.then(function (result) {
										$scope.items = result.data;
										console.log($scope.items);
									});
							}
							break;
						case "state":
							if ($scope.registration.id_country) {
								generalService
									.getMatchingState(query, $scope.registration.id_country)
									.then(function (result) {
										$scope.items = result.data;
										console.log($scope.items);
									});
							}
							break;

						case "country":
							generalService.getMatchingCountry(query).then(function (result) {
								$scope.items = result.data;
								console.log($scope.items);
							});

							break;
					}
				}
			} else {
				$scope.items = "";
			}
		};

		$scope.closeAutocomplete = function () {
			$scope.autocomplete.hide();
		};

		$scope.clearSearch = function () {
			$scope.lookup.searchText = null;
		};

		$scope.postId = function (type, id, name) {
			if (type == "country") {
				$scope.registration.id_country = id;
				$scope.registration.country = name;
				$scope.registration.statename = "";
				$scope.registration.cityname = "";
				$scope.autocomplete.hide();
			}

			if (type == "state") {
				$scope.registration.id_state = id;
				$scope.registration.statename = name;
				$scope.registration.cityname = "";
				$scope.autocomplete.hide();
			}

			if (type == "city") {
				$scope.registration.id_city = id;
				$scope.registration.cityname = name;
				$scope.autocomplete.hide();
			}

			$scope.lookup.searchText = "";
		};

		/*** end of Autocomplete***/

		//update profile
		$scope.profile = function (form) {


			/*     $ionicLoading.show({
				  content: "Loading",
				  template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				  showBackdrop: true,
				  maxWidth: 200,
				  showDelay: 0
				}); */

			if (form.$valid) {

				var allow_submit = false;
				var regexp = /^[a-zA-Z ]*$/;
				var firstname = $scope.registration.firstname;
				var lastname = $scope.registration.lastname;

				var txt = firstname.toUpperCase();
				if (!regexp.test(txt)) {
					ltxt = lastname.toUpperCase();
					if (!regexp.test(ltxt)) {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							cssClass: 'my-custom-popup',
							template: 'Firstname and lastname must contain alphabets only',
						});
						allow_submit = false;
					} else {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							cssClass: 'my-custom-popup',
							template: 'Firstname must contain alphabets only',
						});
						allow_submit = false;
					}
				} else {
					var txt = lastname.toUpperCase();
					if (!regexp.test(txt)) {
						var alertPopup = $ionicPopup.alert({
							title: "Error!",
							cssClass: 'my-custom-popup',
							template: 'Lastname must contain alphabets only',
						});
						allow_submit = false;
					} else {
						allow_submit = true;
					}
				}

				if (allow_submit) {

					$scope.registration.id_customer = generalService.userData.profile.id_customer;
					/*$scope.$watch('registration.date_of_birth', function (newValue) {
					  $scope.registration.date_of_birth = $filter('date')(newValue, 'dd-MM-yyyy');
					});*/
					generalService.updateProfile($scope.registration).then(function (result) {
						console.log($scope.registration);
						generalService.userData.profile.firstname = $scope.registration.firstname;
						generalService.userData.profile.lastname = $scope.registration.lastname;
						$ionicLoading.hide();

						var confirmPopup = $ionicPopup.confirm({
							title: "Profile Update",
							template: result.data.msg
						});

						confirmPopup.then(function (res) {
							if (res) {
								$window.location.href = "#/app/home";
							}
						});
					});
				}
				$ionicLoading.hide();
			} else {
				$ionicLoading.hide();
				if (form.firstName.$invalid) {
					$cordovaToast.show("Enter Valid First Name..", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.lastname.$invalid) {
					$cordovaToast.show("Enter Valid Last Name..", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else if (form.pincode.$invalid) {
					$cordovaToast.show("Enter 6 digit pincode..", "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				} else {
					$cordovaToast.show("Unable to prodeed ,please try after sometime..", "long", "center")
						.then(
							function (success) {
								// success
							},
							function (error) {
								// error
							}
						);
				}
			}
		};

		$scope.showAlert = function (msg) {
			var alertPopup = $ionicPopup.alert({
				title: "Warning Message",
				template: msg
			});
		};

		//on profile page load
		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			//to get countries
			generalService.getCountry().then(function (result) {
				$scope.countries = result.data;
			});

			//to get user details
			generalService.getCustomerByMobile().then(function (result) {
				$scope.registration = result.data;

				//if pincode convert to integer
				if (result.data.pincode != "") {
					$scope.registration.pincode = parseInt(result.data.pincode);
				}

				//if country load city and state
				if (result.data.id_country != "") {
					generalService.getCity(result.data.id_state).then(function (result) {
						$scope.cities = result.data;
					});

					generalService.getState(result.data.id_country).then(function (result) {
						$scope.states = result.data;
					});
				}
				$ionicLoading.hide();
			});
		});
	})

	//notification
	.controller("NotificationCtrl", function ($scope, $filter, generalService, $http, $window, $state, $ionicLoading, $localstorage, $location, $ionicModal, $stateParams, $ionicPopup) {
		$scope.notiDetail = [];
		$scope.removeNoti = function (index) {
			$scope.notifications.splice(index, 1);
			localStorage.setItem(
				"notificationData",
				JSON.stringify($scope.notifications)
			);
		};

		$scope.view_notiDetail = function (notiData) {
			$state.go("app.notidetail", {
				notiDetail: notiData
			});
		};

		//DeleteAll Notifications
		$scope.deleteall = function () {
			var confirmPopup = $ionicPopup.confirm({
				title: "Confirm DeleteAll",
				template: "Are you sure you want to DeleteAll"
			});
			confirmPopup.then(function (res) {
				if (res) {
					$scope.notifications.splice(length);
					localStorage.setItem(
						"notificationData",
						JSON.stringify($scope.notifications)
					);
				}
			});
		};

		$scope.$on("$ionicView.enter", function (e) {
			$scope.logged =
				generalService.userData.logged == undefined ?
					0 :
					generalService.userData.logged;
			$scope.userdata = generalService.userData;
			$scope.isNotiEnabled = generalService.userData.notification;
			console.log(generalService.userData);

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> ',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});

			if ($scope.logged == 1) {
				$scope.notifications = localStorage.getItem("notificationData") !== null ? JSON.parse(localStorage.getItem("notificationData")) : [];
				var empData = $filter("filter")($scope.notifications, {
					mobile: $scope.userdata.mobile
				});
				$scope.notifications = empData;
				if ($scope.notifications.length == 0) {
					$scope.empty = "Your notification list is empty";
				}
			}

			if ($stateParams.notiDetail) {
				$scope.notiDetail = $stateParams.notiDetail;
			}
			$ionicLoading.hide();
		});
	})

	.controller('payOptionsCtrl', function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicLoading, $ionicPlatform, $location, $ionicModal, $ionicHistory) {
		$scope.savedCards = [];
		$scope.selectedCard = [];
		$scope.card_details_array = [];
		$scope.content = [];
		$scope.payuSettings = [];
		$scope.hdfcSettings = [];
		$scope.paynimoSettings = []; // tech process
		$scope.gatewayMsg = "";

		$scope.goToHdfcPg = function () {
			$ionicHistory.nextViewOptions({
				disableBack: true
			});
			$scope.payment_array = JSON.stringify(generalService.payment_array);
			$scope.pay_amt = generalService.total_pay_amt;
			$scope.userdata = generalService.userdata;
			$scope.redeemed_amount = generalService.redeemed_amount;

			$submiturl = generalService.baseurl + "index.php/paymt/mobile_payment?firstname=" + $scope.userdata.firstname + "&lastname=" + $scope.userdata.lastname + "&phone=" + $scope.userdata.mobile + "&amount=" + $scope.pay_amt + "&redeemed_amount=" + $scope.redeemed_amount + "&productinfo=" + $scope.productinfo + "&email=" + $scope.userdata.email + "&pay_arr=" + encodeURIComponent($scope.payment_array) + "&gateway=2";
			paymentWindow = $window.open($submiturl, '_blank', 'location=no, clearsessioncache=yes, closebuttoncaption=Close,footer=yes,hardwareback=no');

			paymentWindow.addEventListener('loadstart', inAppBrowserbLoadStart);
			paymentWindow.addEventListener('loadstop', inAppBrowserbLoadStop);
			paymentWindow.addEventListener('loaderror', inAppBrowserbLoadError);
			paymentWindow.addEventListener('exit', inAppBrowserbClose);

			function inAppBrowserbLoadStart(event) {
				$ionicLoading.show();
				if (event.url == generalService.baseurl + "index.php/paymt/hdfcRedirect/failed") {
					paymentWindow.close();
					$ionicLoading.hide();
					$ionicPopup.alert({
						title: 'Sorry',
						template: 'Your transaction has been failed, Please try again'
					});
					$window.location.href = "#/app/payments/p";
				}

				if (event.url == generalService.baseurl + "index.php/paymt/hdfcRedirect/cancel") {
					paymentWindow.close();
					$ionicLoading.hide();
					$ionicPopup.alert({
						title: 'Sorry',
						template: 'Your transaction has been cancelled , Please try again'
					});
					$window.location.href = "#/app/payments/p";
				}

			}
			function inAppBrowserbLoadStop(event) {
				$ionicLoading.hide();
				if (event.url == (generalService.baseurl + "index.php/paymt/hdfcRedirect/success" || event.url == generalService.baseurl + "index.php/paymt/hdfcRedirect/complete")) {
					paymentWindow.close();
					$ionicPopup.alert({
						title: 'Success',
						template: 'Thank you, Your payment to Bhoopalam Jewellery Saving Scheme processed successfully. Your payment status will be updated on realization.'
					});
					$window.location.href = "#/app/payments/p";
				}
				if (event.url == generalService.baseurl + "index.php/paymt/payment_rejected") {
					paymentWindow.close();
					$ionicPopup.alert({
						title: 'Sorry',
						template: 'We are unable to proceed your request, please try after sometime...'
					});
					$window.location.href = "#/app/payments/p";
				}
			}
			function inAppBrowserbLoadError(event) {
				paymentWindow.close();
				$ionicPopup.alert({
					//	 title: 'Sorry',
					template: 'Payment under Process'
				});
				$window.location.href = "#/app/dashboard";
			}
			function inAppBrowserbClose(event) {
				paymentWindow.removeEventListener('loadstart', iabLoadStart);
				paymentWindow.removeEventListener('loadstop', iabLoadStop);
				paymentWindow.removeEventListener('loaderror', iabLoadError);
				paymentWindow.removeEventListener('exit', iabClose);
				$ionicLoading.hide();
			}
		}

		$scope.goToPaynimoPg = function () {
			$ionicHistory.nextViewOptions({
				disableBack: true
			});
			$scope.payment_array = JSON.stringify(generalService.payment_array);
			$scope.pay_amt = generalService.total_pay_amt;
			$scope.userdata = generalService.userData.profile;
			$scope.redeemed_amount = generalService.redeemed_amount;

			/*$submiturl = generalService.baseurl + "index.php/paymt/mobile_payment?firstname=" + $scope.userdata.firstname + "&lastname=" + $scope.userdata.lastname + "&phone=" + $scope.userdata.mobile + "&amount=" + $scope.pay_amt + "&productinfo=" + $scope.productinfo + "&email=" + $scope.userdata.email + "&pg=" + $scope.content.card_type + "&bankcode=" + bankcode + "&card_token=" + $scope.content.card_token + "&ccnum=" + $scope.content.card_no + "&ccname=" + $scope.content.name_on_card + "&ccvv=" + $scope.content.ccvv + "&ccexpmon=" + $scope.content.expiry_month + "&ccexpyr=" + $scope.content.expiry_year + "&gateway=3" +  "&pay_arr=" + encodeURIComponent($scope.payment_array);*/

			$submiturl = generalService.baseurl + "index.php/paymt/mobile_payment?firstname=" + $scope.userdata.firstname + "&lastname=" + $scope.userdata.lastname + "&phone=" + $scope.userdata.mobile + "&amount=" + $scope.pay_amt + "&redeemed_amount=" + $scope.redeemed_amount + "&productinfo=" + $scope.productinfo + "&email=" + "&pg=NB" + "&gateway=3" + "&pay_arr=" + encodeURIComponent($scope.payment_array);

			paymentWindow = $window.open($submiturl, '_blank', 'location=no, clearsessioncache=yes, closebuttoncaption=Close,footer=yes,hardwareback=no');

			paymentWindow.addEventListener('loadstart', inAppBrowserbLoadStart);
			paymentWindow.addEventListener('loadstop', inAppBrowserbLoadStop);
			paymentWindow.addEventListener('loaderror', inAppBrowserbLoadError);
			paymentWindow.addEventListener('exit', inAppBrowserbClose);

			function inAppBrowserbLoadStart(event) {
				$ionicLoading.show();
				if (event.url == generalService.baseurl + "index.php/paymt/failureMURL") {
					paymentWindow.close();
					$ionicLoading.hide();
					$ionicPopup.alert({
						title: 'Sorry',
						template: 'Your transaction has been failed, Please try again'
					});
					$window.location.href = "#/app/payments/p";
				}

				if (event.url == generalService.baseurl + "index.php/paymt/cancelMURL") {
					paymentWindow.close();
					$ionicLoading.hide();
					$ionicPopup.alert({
						title: 'Sorry',
						template: 'Your transaction has been cancelled , Please try again'
					});
					$window.location.href = "#/app/payments/p";
				}

			}

			function inAppBrowserbLoadStop(event) {
				$ionicLoading.hide();
				//	alert(event.type + ' stop : success ' + event.url);
				if (event.url == generalService.baseurl + "index.php/paymt/successMURL") {
					paymentWindow.close();
					$ionicPopup.alert({
						title: 'Success',
						template: 'Thanks for your payment with us.Your payment (sub. to realisation) is processed successfully.'
					});
					//	alert('1');
					$window.location.href = "#/app/payments/p";
				}
			}

			function inAppBrowserbLoadError(event) {
				//	alert(event.type + ' error : ' + event.url);
				paymentWindow.close();
				$ionicPopup.alert({
					//	title: 'Sorry',
					template: 'Payment Under Process'
				});
				$window.location.href = "#/app/home";
			}

			function inAppBrowserbClose(event) {
				paymentWindow.removeEventListener('loadstart', iabLoadStart);
				paymentWindow.removeEventListener('loadstop', iabLoadStop);
				paymentWindow.removeEventListener('loaderror', iabLoadError);
				paymentWindow.removeEventListener('exit', iabClose);
				$ionicLoading.hide();
			}
		}

		$scope.creditcard = function (pg_code, savecard) {
			$state.go("app.creditcard", { 'gateway': pg_code, 'showSaveOption': savecard });
		}
		$scope.debitcard = function (pg_code, savecard) {
			$state.go("app.debitcard", { 'gateway': pg_code, 'showSaveOption': savecard });
		}
		$scope.netbanking = function () {
			console.log($scope.banks);
			if ($scope.banks.length > 0 || $scope.banks != '') {
				$state.go("app.netbanking", { 'nbData': $scope.banks });
			}
		}
		$scope.deletecards = function (cardtoken, index) {
			$ionicLoading.show();
			$scope.storedCards = generalService.storedCards;
			generalService.deleteCards(cardtoken).then(function (result) {
				$ionicLoading.hide();
				if (result.data.status == 1) {
					$scope.storedCards = generalService.storedCards;
					$scope.storedCards.splice(index, 1);
					if ($scope.storedCards.length == 0) {
						$scope.errormsg = "No Saved Cards Available";
					}
					$cordovaToast
						.show(result.data.msg, 'long', 'center')
						.then(function (success) {
							// success
						}, function (error) {
							// error
						});
				}
			})
			$ionicLoading.hide();
		}
		//loading cards when page opens
		$scope.$on('$ionicView.enter', function (e) {
			$scope.banks = [];
			generalService.getAllPG().then(function (result) {
				if (result.data) {
					console.log(result.data.pgData);
					$scope.gatewayMsg = result.data.msg;
					$scope.ccBrand = result.data.cc; // payU active brands
					$scope.dcBrand = result.data.dc; // payU active brands
					angular.forEach(result.data.pgData, function (value, key) {
						if (value['pg_code'] == 1) {
							$scope.payuSettings = value;
						} else if (value['pg_code'] == 2) {
							$scope.hdfcSettings = value;
						} else if (value['pg_code'] == 3) {
							$scope.paynimoSettings = value; // tech process
						}
					});
				}
			})

			/*console.log($scope.currency);
			$scope.paycurrentchit = [];
			$scope.paycurrentchit = generalService.currentpayment;
			$scope.pay_amt = parseFloat($scope.paycurrentchit.amount)+parseFloat($scope.paycurrentchit.charge);
			$ionicLoading.show();*/
			$scope.currency = generalService.currency;
			$scope.payment_array = generalService.payment_array;
			$scope.pay_amt = generalService.total_pay_amt;
			console.log(generalService.total_pay_amt);
			$ionicLoading.show();

			generalService.savedCards().then(function (result) {
				if (result.data) {
					if (result.data) {
						$scope.creditCards = result.data.ibiboCodes.creditcard;
						$scope.debitCards = result.data.ibiboCodes.debitcard;
						//	$scope.banks = result.data.ibiboCodes.netbanking;
					}
					if (result.data.userCards) {
						if (result.data.userCards.status == 0) {
							$scope.errormsg = "No Saved Cards Available";
							console.log($scope.errormsg);
						}
						else if (result.data.userCards.status == 1) {
							var res = [];
							for (var x in result.data.userCards.user_cards) {
								result.data.userCards.user_cards.hasOwnProperty(x) && res.push(result.data.userCards.user_cards[x])
							}
							$scope.storedCards = res;
							//					generalService.storedCards=res;
							//$scope.Status=result.data.userCards.status;
						}
						$ionicLoading.hide();
					}
				}
				else {
					$scope.errormsg = "Sorry, Something went wrong.Please try after sometime..";
					console.log($scope.errormsg);
					$ionicLoading.hide();
				}
				$ionicLoading.hide();
			})

			/*generalService.getActivecardBrands().then(function (result) {
				if (result.data) {
					$scope.ccBrand = result.data.cc;
					$scope.dcBrand = result.data.dc;
				}
				else {
					$scope.errormsg = "Sorry, Something went wrong.Please try after sometime..";
					console.log($scope.errormsg);					 
				}				 
			})*/

			generalService.getNetbankingStatus().then(function (result) {
				if (result.data) {
					$scope.banks = result.data;
					console.log('NB : ' + JSON.stringify(result.data));
				}
				else {
					$scope.errormsg = "Sorry, Something went wrong.Please try after sometime..";
					console.log($scope.errormsg);
					/*$ionicLoading.hide();	*/
				}
				$ionicLoading.hide();
			})

		})

		// card onclick
		$scope.cvvModal = function (savedcard) {
			$scope.showModal('templates/cardmodal.html', savedcard);
		}

		$scope.showModal = function (templateUrl, savedcard) {//, $scope.card_details_array
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: 'slide-in-up'
			}).then(
				function (modal) {
					$scope.modal = modal;
					$scope.content = savedcard;
					$scope.type = 2;
					$scope.modal.show();
				});
		}

		$scope.showSummaryModal = function (templateUrl, type, content) {
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: 'slide-in-up'
			}).then(function (modal) {
				$scope.modal = modal;
				$scope.type = type;
				$scope.content = content;
				$scope.modal.show();
			});
		}



		$scope.submitForm = function (form) {
			$scope.payment_array = JSON.stringify(generalService.payment_array);
			$scope.pay_amt = generalService.total_pay_amt;


			/*$scope.paycurrentchit = [];
			$scope.paycurrentchit = generalService.currentpayment;
			console.log($scope.paycurrentchit);
			$scope.pay_amt = parseFloat($scope.paycurrentchit.amount)+parseFloat($scope.paycurrentchit.charge);
			$scope.allowpay=false;*/
			if (form.$valid) {
				$scope.userdata = generalService.userData.profile;
				$scope.redeemed_amount = generalService.redeemed_amount;
				console.log(generalService.userData);
				if ($scope.content.card_type != undefined) {
					console.log($scope.content);
					$ionicLoading.show();

					var bankcode = $scope.content.pg == "NB" ? $scope.content.bank : "CC";
					$scope.productinfo = "";

					$submiturl = generalService.baseurl + "index.php/paymt/mobile_payment?firstname=" + $scope.userdata.firstname + "&lastname=" + $scope.userdata.lastname + "&phone=" + $scope.userdata.mobile + "&amount=" + $scope.pay_amt + "&redeemed_amount=" + $scope.redeemed_amount + "&productinfo=" + $scope.productinfo + "&email=" + $scope.userdata.email + "&pg=" + $scope.content.card_type + "&bankcode=" + bankcode + "&card_token=" + $scope.content.card_token + "&ccnum=" + $scope.content.card_no + "&ccname=" + $scope.content.name_on_card + "&ccvv=" + $scope.content.ccvv + "&ccexpmon=" + $scope.content.expiry_month + "&ccexpyr=" + $scope.content.expiry_year + "&gateway=2" + "&pay_arr=" + encodeURIComponent($scope.payment_array);

					paymentWindow = $window.open($submiturl, '_blank', 'location=no, clearsessioncache=yes');


					paymentWindow.addEventListener('loadstart', inAppBrowserbLoadStart);
					paymentWindow.addEventListener('loadstop', inAppBrowserbLoadStop);
					paymentWindow.addEventListener('loaderror', inAppBrowserbLoadError);
					paymentWindow.addEventListener('exit', inAppBrowserbClose);

					function inAppBrowserbLoadStart(event) {
						$ionicLoading.show();
						//	alert(event.type + ' start : ' + event.url);
						if (event.url == generalService.baseurl + "index.php/paymt/failureMURL") {
							paymentWindow.close();
							$ionicLoading.hide();
							$scope.modal.hide();
							$scope.modal.remove();
							$ionicPopup.alert({
								title: 'Sorry',
								template: 'Your transaction has been failed, Please try again'
							});
							$window.location.href = "#/app/home";
						}

						if (event.url == generalService.baseurl + "index.php/paymt/cancelMURL") {
							paymentWindow.close();
							$ionicLoading.hide();
							$scope.modal.hide();
							$scope.modal.remove();
							$ionicPopup.alert({
								title: 'Sorry',
								template: 'Your transaction has been cancelled , Please try again'
							});
							$window.location.href = "#/app/home";
						}

					}

					function inAppBrowserbLoadStop(event) {
						$ionicLoading.hide();
						//	alert(event.type + ' stop : success ' + event.url);
						if (event.url == generalService.baseurl + "index.php/paymt/successMURL") {
							paymentWindow.close();
							$scope.modal.hide();
							$scope.modal.remove();
							$ionicPopup.alert({
								title: 'Success',
								template: 'Thanks for your payment with us.Your payment (sub. to realisation) is processed successfully.'
							});
							//	alert('1');
							$window.location.href = "#/app/home";
						}
					}

					function inAppBrowserbLoadError(event) {
						//	alert(event.type + ' error : ' + event.url);
						paymentWindow.close();
						$scope.modal.hide();
						$scope.modal.remove();
						$ionicPopup.alert({
							//	title: 'Sorry',
							template: 'Payment Under Process'
						});
						$window.location.href = "#/app/home";
					}

					function inAppBrowserbClose(event) {
						//	alert('close :'+event.type);
						paymentWindow.removeEventListener('loadstart', iabLoadStart);
						paymentWindow.removeEventListener('loadstop', iabLoadStop);
						paymentWindow.removeEventListener('loaderror', iabLoadError);
						paymentWindow.removeEventListener('exit', iabClose);
						$ionicLoading.hide();
					}
				}
				else {
					$scope.errormsg = "Please enter valid data";
				}
			}

			else {
				$scope.allowpay = true;
				$scope.errormsg = "Please enter valid data";
			}
		}

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};
	})

	//savedCardCtrl
	.controller("savedCardCtrl", function ($scope, generalService, $http, $window, $state, $ionicPopup, $ionicLoading, $ionicPlatform, $stateParams) {
		$scope.payurl = [];
		$scope.paycurrentchit = [];
		$scope.payupaydetails = [];
		$scope.savedCards = [];
		$scope.selectedCard = [];

		$scope.deletecards = function (cardtoken, index) {
			$ionicLoading.show();
			$scope.storedCards = generalService.storedCards;
			generalService.deleteCards(cardtoken).then(function (result) {
				$ionicLoading.hide();
				if (result.data.status == 1) {
					$scope.storedCards = generalService.storedCards;
					$scope.storedCards.splice(index, 1);
					if ($scope.storedCards.length == 0) {
						$scope.errormsg = "No Saved Cards Available";
					}
					$cordovaToast.show(result.data.msg, "long", "center").then(
						function (success) {
							// success
						},
						function (error) {
							// error
						}
					);
				}
			});
			$ionicLoading.hide();
		};

		$scope.$on("$ionicView.enter", function (e) {
			$ionicLoading.show();
			generalService.savedCards().then(function (result) {
				if (result.data.userCards) {
					if (result.data.userCards.status == 0) {
						$scope.errormsg = "No Saved Cards Available";
						console.log($scope.errormsg);
					} else if (result.data.userCards.status == 1) {
						var res = [];
						for (var x in result.data.userCards.user_cards) {
							result.data.userCards.user_cards.hasOwnProperty(x) &&
								res.push(result.data.userCards.user_cards[x]);
						}
						$scope.storedCards = res;
						generalService.storedCards = res;
						$scope.Status = result.data.userCards.status;
					}

					$ionicLoading.hide();
				} else {
					$scope.errormsg =
						"Sorry,Something went wrong.Please try after sometime..";
					console.log($scope.errormsg);
					$ionicLoading.hide();
				}

				$ionicLoading.hide();
			});
		});

		$ionicLoading.hide();
	})
	.controller("NavCtrl", function ($scope, $ionicSideMenuDelegate, $stateParams) {
		$scope.$on("$ionicView.enter", function () {
			angular.element(document.querySelector(".app-header")).addClass("hideBar");
			angular.element(document.querySelector(".app-footer")).addClass("hideBar");
			$ionicSideMenuDelegate.canDragContent(false);
			$scope.text = $stateParams.text;
			$scope.comp = $stateParams.comp;
		});
		$scope.$on("$ionicView.leave", function () {
			$ionicSideMenuDelegate.canDragContent(true);
		});
	})

	.controller("CheckCtrl", function ($scope, $state, $window, $ionicPopup, $stateParams, $ionicPlatform, $ionicLoading, generalService, $ionicModal, $cordovaSplashscreen, $rootScope) {
		$ionicLoading.show();
		var appVersion = 0;

		// Close the modal
		$rootScope.closeimgModal = function () {
			$rootScope.modal.hide();
			$rootScope.modal.remove();
			$window.location.href = "#/app/home";
		};
		$ionicPlatform.ready(function () {
			cordova.getAppVersion(function (version) {
				appVersion = version;
				generalService.getVersion().then(function (data) {
					//maintenance check
					if (data.data.mode == 1) {
						$ionicLoading.hide();
						$cordovaSplashscreen.hide();
						$state.go('maintenance', { comp: data.data.comp, text: data.data.text })
					} else {
						$ionicLoading.hide();
						$cordovaSplashscreen.hide();
						//version check
						if (data.data) {
							if (ionic.Platform.isAndroid()) {
								var checkver = data.data.new_android_ver != undefined && data.data.android != undefined ? data.data.android != appVersion ? data.data.new_android_ver != appVersion : false : false;
								if (checkver) {
									var alertPopup = $ionicPopup.alert({
										title: "New Version Available",
										template: data.data.msg
									});

									alertPopup.then(function (res) {
										//	console.log(data.data.comp.playstore_url);
										window.location = data.data.comp.playstore_url; // playstore url
										ionic.Platform.exitApp();
									});
								} else {
									//TO SHOWPOPUP
									if (data.data.showpopup == 1) {
										$ionicModal.fromTemplateUrl("templates/img-popup.html", {
											scope: $rootScope,
											hardwareBackButtonClose: false,
											animation: "slide-in-up"
										})
											.then(function (modal) {
												$rootScope.modal = modal;
												$rootScope.img = data.data.popupimg;
												$rootScope.modal.show();
											});
									} else {
										$window.location.href = "#/app/home";
									}
								}
							}

						} else {
							var alertPopup = $ionicPopup.alert({
								title: "Something went wrong !!"
							});
							alertPopup.then(function (res) {
								ionic.Platform.exitApp();
							});
						}
					}
				});
			});
		});
	})

	.controller("CategoryCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal, $ImageCacheFactory) {
		//on load view
		$scope.categories = [];
		$scope.sub_category = [];

		$scope.openSubCategory = function (id_category) {
			$state.go("app.collections", {
				sub_category: id_category
			});
		};

		$scope.$on("$ionicView.enter", function (e) {
			$scope.sub_category = [];

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
			});

			generalService.viewall_parentcategory().then(function (result) {
				if (result.data) {
					console.log(JSON.stringify(result.data));
					$scope.categories = result.data;
				} else {
					$scope.errormsg = "";
				}
				$ionicLoading.hide();
			});
		});
	})

	.controller("subcategoryCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal, $ImageCacheFactory, $stateParams) {
		$scope.viewProduct = function (id_product) {
			$state.go("app.productdetail", {
				productId: id_product
			});
		};

		$scope.opensubCategories = function (id_category) {
			generalService.view_subparent_category(id_category).then(function (result) {
				if (result.data) {
					$scope.products = [];
					$scope.sub_category = [];
					console.log(result.data);
					if (result.data.type == "product") {
						$scope.products = result.data.responseData;
						$scope.errormsg = result.data.msg;
						//	alert('product : '+JSON.stringify(result.data.msg)+""+JSON.stringify(result.data.type));
					} else {
						$scope.sub_category = result.data.responseData;
						$scope.errormsg = "";
						//	alert('subcat : '+JSON.stringify(result.data.msg)+""+JSON.stringify(result.data.type));
					}
				} else {
					$scope.error = "";
				}
			});
		};

		$scope.$on("$ionicView.enter", function (e) {
			$scope.sub_category = [];
			$scope.products = [];
			$scope.error = "";

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
			});

			generalService
				.view_subparent_category($stateParams.sub_category)
				.then(function (result) {
					if (result.data) {
						console.log(result.data);
						if (result.data.type == "product") {
							$scope.products = result.data.responseData;
							$scope.errormsg = result.data.msg;
							//	alert('subparentcat : '+JSON.stringify(result.data.msg)+""+JSON.stringify(result.data.type));
						} else {
							$scope.sub_category = result.data.responseData;
							console.log("sb " + JSON.stringify(result.data.responseData));
							$scope.errormsg = "";
							//	alert('subcat_cat : '+JSON.stringify(result.data.msg)+""+JSON.stringify(result.data.type));
						}
					} else {
						$scope.error = "";
					}
				});
		});
	})

	.controller("productDetailCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal, $ImageCacheFactory, $stateParams) {

		$scope.$on("$ionicView.enter", function (e) {
			$scope.product = [];

			$ionicLoading.show({
				content: "Loading",
				template: 'Please wait <br/><ion-spinner icon="dots" class="spinner-energized"></ion-spinner> '
			});

			generalService
				.productDetail({
					id_product: $stateParams.productId
				})
				.then(function (result) {
					if (result.data) {
						$scope.product = result.data;
					} else {
						$scope.error = "";
					}
				});
		});

		$scope.zoomImage = function () {
			$scope.showModal("templates/imageZoomView.html");
		};

		$scope.showModal = function (templateUrl) {
			$ionicModal
				.fromTemplateUrl(templateUrl, {
					scope: $scope,
					animation: "slide-in-up"
				})
				.then(function (modal) {
					$scope.modal = modal;
					$scope.type = 5;
					$scope.modal.show();
				});
		};

		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};


	})

	.directive("compareTo", function () {
		return {
			require: "ngModel",
			scope: {
				otherModelValue: "=compareTo"
			},
			link: function (scope, element, attributes, ngModel) {
				ngModel.$validators.compareTo = function (modelValue) {
					return modelValue == scope.otherModelValue;
				};

				scope.$watch("otherModelValue", function () {
					ngModel.$validate();
				});
			}
		};
	})

	.factory("checkInternet", function () {
		return function checkInternet() {
			var haveInternet = true;
			if (window.cordova) {
				if (window.Connection) {
					if (navigator.connection.type == Connection.NONE) {
						haveInternet = false;
					}
				}
			}
			return haveInternet;
		};
	})

	.directive("zoomable", function (ScrollRender) {
		return {
			link: function (scope, element, attrs) {
				element.bind("load", function () {
					// Intialize layout
					var container = document.getElementById("container");
					var content = document.getElementById("content");
					var clientWidth = 0;
					var clientHeight = 0;

					// Initialize scroller
					var scroller = new Scroller(ScrollRender.render(content), {
						scrollingX: true,
						scrollingY: true,
						animating: true,
						bouncing: true,
						locking: true,
						zooming: true,
						minZoom: 0.5,
						maxZoom: 2
					});

					// Initialize scrolling rect
					var rect = container.getBoundingClientRect();
					scroller.setPosition(
						rect.left + container.clientLeft,
						rect.top + container.clientTop
					);

					var image = document.getElementById("image-scrollable");
					var contentWidth = image.width;
					var contentHeight = image.height;

					// Reflow handling
					var reflow = function () {
						clientWidth = container.clientWidth;
						clientHeight = container.clientHeight;
						scroller.setDimensions(
							clientWidth,
							clientHeight,
							contentWidth,
							contentHeight
						);
					};

					window.addEventListener("resize", reflow, false);
					reflow();

					if ("ontouchstart" in window) {
						container.addEventListener(
							"touchstart",
							function (e) {
								// Don't react if initial down happens on a form element
								if (
									e.touches[0] &&
									e.touches[0].target &&
									e.touches[0].target.tagName.match(/input|textarea|select/i)
								) {
									return;
								}

								scroller.doTouchStart(e.touches, e.timeStamp);
								e.preventDefault();
							},
							false
						);

						document.addEventListener(
							"touchmove",
							function (e) {
								scroller.doTouchMove(e.touches, e.timeStamp, e.scale);
							},
							false
						);

						document.addEventListener(
							"touchend",
							function (e) {
								scroller.doTouchEnd(e.timeStamp);
							},
							false
						);

						document.addEventListener(
							"touchcancel",
							function (e) {
								scroller.doTouchEnd(e.timeStamp);
							},
							false
						);
					} else {
						var mousedown = false;

						container.addEventListener(
							"mousedown",
							function (e) {
								if (e.target.tagName.match(/input|textarea|select/i)) {
									return;
								}

								scroller.doTouchStart(
									[{
										pageX: e.pageX,
										pageY: e.pageY
									}],
									e.timeStamp
								);

								mousedown = true;
							},
							false
						);

						document.addEventListener(
							"mousemove",
							function (e) {
								if (!mousedown) {
									return;
								}

								scroller.doTouchMove(
									[{
										pageX: e.pageX,
										pageY: e.pageY
									}],
									e.timeStamp
								);

								mousedown = true;
							},
							false
						);

						document.addEventListener(
							"mouseup",
							function (e) {
								if (!mousedown) {
									return;
								}

								scroller.doTouchEnd(e.timeStamp);

								mousedown = false;
							},
							false
						);

						container.addEventListener(
							navigator.userAgent.indexOf("Firefox") > -1 ?
								"DOMMouseScroll" :
								"mousewheel",
							function (e) {
								scroller.doMouseZoom(
									e.detail ? e.detail * -120 : e.wheelDelta,
									e.timeStamp,
									e.pageX,
									e.pageY
								);
							},
							false
						);
					}
				});
			}
		};
	})

	//Carrier Enquiry Detail Page
	.controller("CarrierCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $cordovaToast, $cordovaCamera, tabsignup, $cordovaFile, $cordovaFileTransfer, $cordovaActionSheet, $cordovaDevice) {
		$scope.$on("$ionicView.enter", function (scopes, states, fileUpload) {
			$scope.carrierData = [];
			$scope.user = generalService.userData.profile;
			$scope.image = null;

			$scope.uploadFile = function () {
				var customHeaders = "foo:123,bar:456";
				cordova.InAppBrowser.open("http://cpljewellers.com", "_blank", "location=yes,zoom=no,footer=yes,footercolor=#00ff00,hidenavigationbuttons=no,navigationbuttoncolor=#00ff00,closebuttoncolor=#00ff00", "closebuttoncaption=Back", customHeaders);
			};
			$scope.send_carrier = function (form) {
				$window.location.href = "#/app/home";
			};
		});
	})

	//ShowRoom Ctrl
	.controller("ShowroomCtrl", function ($scope, generalService, $http, $window, $state, $ionicLoading, $location, $ionicModal) {

		$scope.zoomImage = function () {
			$scope.showModal("templates/imageZoomView.html");
		};

		$scope.showModal = function (templateUrl) {
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: "slide-in-up"
			}).then(function (modal) {
				$scope.modal = modal;
				$scope.type = 6;
				$scope.modal.show();
			});
		};



		// Close the modal
		$scope.closeModal = function () {
			$scope.modal.hide();
			$scope.modal.remove();
		};

		$scope.zoomImagenew = function () {
			$scope.showModalnew("templates/imageZoomView.html");
		};

		$scope.showModalnew = function (templateUrl) {
			$ionicModal.fromTemplateUrl(templateUrl, {
				scope: $scope,
				animation: "slide-in-up"
			}).then(function (modal) {
				$scope.modal = modal;
				$scope.type = 7;
				$scope.modal.show();
			});
		};

	})

	.directive("dynamicSlides", function () {
		return {
			require: ["^ionSlideBox"],
			link: function (scope, elem, attrs, slider) {
				scope.$watch(
					function () {
						return scope.$eval(attrs.dynamicSlides).length;
					},
					function (val) {
						slider[0].__slider.update();
						if (scope.$last) {
							// all are rendered
							scope.$eval(attrs.dynamicSlides);
						}
					}
				);
			}
		};
	})
	.filter("custom", function () {
		return function (input, search) {
			if (!input) return input;
			if (!search) return input;
			var expected = ("" + search).toLowerCase();
			var result = {};
			angular.forEach(input, function (value, key) {
				var actual = ("" + value).toLowerCase();
				if (actual.indexOf(expected) !== -1) {
					result[key] = value;
				}
			});
			return result;
		};
	})
